Attribute VB_Name = "APIKernel"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Declare Sub CopyMem Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
    pDest As Any, _
    pSource As Any, _
    ByVal ByteLen As Long)
    
Declare Function GetLastError Lib "kernel32.dll" () As Long

Private Declare Function GetVersion Lib "kernel32.dll" () As Long

Private Type TVersion
    lVersion As Long
End Type

Private Type TVersionBytes
    bV1 As Byte
    bV2 As Byte
    bV3 As Byte
    bV4 As Byte
End Type
    
Public Function IsWinXP() As Boolean
    Dim tV As TVersion
    Dim tVB As TVersionBytes

    tV.lVersion = GetVersion()
    LSet tVB = tV
    
    If tVB.bV1 = 5 And tVB.bV2 = 1 Then
        IsWinXP = True
    Else
        IsWinXP = False
    End If
End Function
    
    

