VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PopupMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oPopup As Popup

Private oPopupItems As PopupItems
'
' Properties
'
Public Property Get PopupItems() As PopupItems
    If oPopupItems Is Nothing Then
        Set oPopupItems = New PopupItems
        Set oPopupItems.Popup = oPopup
    End If
    Set PopupItems = oPopupItems
End Property

Friend Property Set Popup(NewVal As Object)
    Set oPopup = NewVal
End Property

Private Sub Class_Initialize()
    Set oPopupItems = Nothing
End Sub

Public Sub CleanUp()
    If Not oPopupItems Is Nothing Then
        oPopupItems.CleanUp
        Set oPopupItems = Nothing
    End If
End Sub

