VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form frmTrace 
   Caption         =   "Database Manager Debug Server - Trace"
   ClientHeight    =   3900
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6225
   Icon            =   "Trace.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3900
   ScaleWidth      =   6225
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CDL 
      Left            =   5700
      Top             =   60
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.ListBox lstTrace 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3840
      IntegralHeight  =   0   'False
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5655
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFSave 
         Caption         =   "&Save As..."
      End
      Begin VB.Menu mnuFSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      Begin VB.Menu mnuVClear 
         Caption         =   "&Clear"
      End
      Begin VB.Menu mnuVSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuVTop 
         Caption         =   "&Always on top"
         Checked         =   -1  'True
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "frmTrace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function SetWindowPos Lib "user32.dll" ( _
    ByVal hwnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) As Long

Const HWND_TOP = 0
Const HWND_BOTTOM = 1
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2

Private lRC As Long

'''

Private Sub Form_Load()
    SetTop mnuVTop.Checked
End Sub

Private Sub Form_Resize()
    lstTrace.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

'''

Private Sub mnuFExit_Click()
    Unload Me
End Sub

Private Sub mnuFSave_Click()
    With CDL
        .DialogTitle = "Save As"
        .FileName = App.Path & "\Trace.log"
        .Filter = "Trace Files(*.log)|*.log|Text Files(*.txt)|*.txt|All Files|*.*"
        .FilterIndex = 1
        .Flags = cdlOFNHideReadOnly
        .CancelError = True
    End With
    
    On Error Resume Next
    
    CDL.ShowSave
    
    If Err.Number = cdlCancel Then
        On Error GoTo 0
        Exit Sub
    Else
        On Error GoTo 0
        SaveTraceLog CDL.FileName
    End If
End Sub

'''

Private Sub mnuVClear_Click()
    lstTrace.Clear
End Sub

Private Sub mnuVTop_Click()
    mnuVTop.Checked = Not mnuVTop.Checked
    SetTop mnuVTop.Checked
End Sub

'''

Private Sub SetTop(ByVal bTop As Boolean)
    If bTop Then
        lRC = SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE)
    Else
        lRC = SetWindowPos(Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE)
    End If
End Sub

Private Sub SaveTraceLog(sFileName As String)
    Dim iFile As Integer
    Dim iLine As Integer
    
    iFile = FreeFile()
    
    Open sFileName For Output As iFile
    
    For iLine = 1 To lstTrace.ListCount
        Print #iFile, lstTrace.List(iLine)
    Next
    Close #iFile
End Sub
