VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocDevSpaces 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7410
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   7410
   ToolboxBitmap   =   "DBMDocDevSpaces.ctx":0000
   Begin MSComctlLib.ListView lvwDevSpaces 
      Height          =   2175
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   3836
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Size"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Type"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Location"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMDoc.DBMDocDevSpace docDevSpace 
      Height          =   1695
      Left            =   4140
      TabIndex        =   0
      Top             =   420
      Visible         =   0   'False
      Width           =   2415
      _ExtentX        =   4260
      _ExtentY        =   2990
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2880
      Top             =   720
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2880
      Top             =   360
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   3150
      Width           =   7410
      _ExtentX        =   13070
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   2880
      Top             =   1080
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin VB.Menu mnuDevSpaces 
      Caption         =   "DevSpaces"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocDevSpaces"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Public Enum DBMDocDevSpacesCommands
    cmdDevSpaces
    cmdDevSpaceEdit
    cmdDevSpaceDeleteSep
    cmdDevSpaceDelete
    cmdDevSpacesRefreshSep
    cmdDevSpacesRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdDevSpaces
Const CMD_LAST = cmdSeperator

Private Enum DevSpacesPopupConstants
    popDevSpaces = 1
    popDevSpace
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''

Public Enum DBMDevSpacesModeConstants
    dbmDevSpacesModeDefault
    dbmDevSpacesModeInit
    dbmDevSpacesModeData
    dbmDevSpacesModeLog
    dbmDevSpacesModeLogMode
End Enum

Private lMode As DBMDevSpacesModeConstants

'''

Private bAsynchron As Boolean

Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

Private oDevSpaces As DBMLib.DevSpaces

'''

Private Enum DevSpavcesColumnConstants
    dcName
    dcSize
    dcType
    dcLocation
    dcMLocation
    dcMType
End Enum

'''

Private oItemAct As MSComctlLib.ListItem
Private bItemClick As Boolean

Private oDevSpaceOpen As DBMLib.DevSpace

Private lState As DBMLib.DBMDatabaseStateConstants

Private oNextLog As DBMLib.DevSpace
Private oNextData As DBMLib.DevSpace

'''

Private lNewLogMode As DBMLib.DBMLogModeConstants

'''

Private lSenderID As Long

'''

Public Event WrongDBState()

Public Event DevSpaceClick(ByVal DevSpace As DBMLib.DevSpace)

Public Event DevSpaceEdit(ByVal DevSpace As DBMLib.DevSpace)
Public Event DevSpaceDelete(ByVal DevSpace As DBMLib.DevSpace)
Public Event DevSpaceOK(ByVal DevSpace As DBMLib.DevSpace)
Public Event DevSpaceCancel(ByVal DevSpace As DBMLib.DevSpace)

Public Event CommandBefore(Command As DBMDocDevSpacesCommands, Cancel As Boolean)
Public Event CommandAfter(Command As DBMDocDevSpacesCommands)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_DEVSPACES
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - "
    Select Case lMode
        Case dbmDevSpacesModeDefault:   s = s + RS(IDS_G6_DEVSPACES)
        Case dbmDevSpacesModeInit:      s = s + RS(IDS_G6_DEVSPACES)
        Case dbmDevSpacesModeData:      s = s + RS(IDS_G6_DATADEVSPACES)
        Case dbmDevSpacesModeLog:       s = s + RS(IDS_G6_LOGDEVSPACES)
        Case dbmDevSpacesModeLogMode:   s = s + RS(IDS_G6_LOGDEVSPACES)
    End Select
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Get Database() As DBMLib.Database
    Set Database = oDB
End Property
Public Property Set Database(ByVal NewVal As DBMLib.Database)
    Set oDB = NewVal
    
    If Not oDB Is Nothing Then
        Set oDevSpaces = oDB.DevSpaces
    End If
    
    TIBCaption oTIB, Caption
End Property

Public Property Get Mode() As DBMDevSpacesModeConstants
    Mode = lMode
End Property
Public Property Let Mode(ByVal NewVal As DBMDevSpacesModeConstants)
    lMode = NewVal
    
    Select Case lMode
        Case dbmDevSpacesModeDefault, dbmDevSpacesModeData, dbmDevSpacesModeLog:
            docDevSpace.Mode = dbmDevSpaceModeDefault
        Case dbmDevSpacesModeInit:
            docDevSpace.Mode = dbmDevSpaceModeInit
        Case dbmDevSpacesModeLogMode
            docDevSpace.Mode = dbmDevSpaceModeLogMode
    End Select
    
    CommandsMode
    TIBCaption oTIB, Caption
    PropertyChanged "Mode"
End Property

Public Property Get Asynchron() As Boolean
    Asynchron = bAsynchron
End Property
Public Property Let Asynchron(ByVal NewVal As Boolean)
    bAsynchron = NewVal
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    docDevSpace.ToolBar = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
        CommandsSet False, bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    If Not oDB Is Nothing Then
        At = oDB.DevSpaces.At
    Else
        At = Empty
    End If
End Property

Public Property Get Complete() As Boolean
    Complete = False
    If Not oDevSpaces Is Nothing Then
        Complete = oDevSpaces.Complete
    End If
End Property

Public Property Get CompleteMirroredLog() As Boolean
    CompleteMirroredLog = False
    If Not oDevSpaces Is Nothing Then
        CompleteMirroredLog = oDevSpaces.CompleteMirroredLog
    End If
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        With CML.CommandItems
            Select Case lMode
                Case dbmDevSpacesModeDefault:   .Item(cmdDevSpaces).Caption = "Volumes"
                Case dbmDevSpacesModeInit:      .Item(cmdDevSpaces).Caption = "Volumes"
                Case dbmDevSpacesModeData:      .Item(cmdDevSpaces).Caption = "DataVolumes"
                Case dbmDevSpacesModeLog:       .Item(cmdDevSpaces).Caption = "LogVolumes"
                Case dbmDevSpacesModeLogMode:   .Item(cmdDevSpaces).Caption = "LogVolumes"
            End Select
        End With
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Function Refresh(Optional LostQuestion As Boolean = False) As Boolean
    Refresh = DevSpacesRefresh(LostQuestion)
End Function

Public Sub Show(Optional ByVal NewLogMode As DBMLib.DBMLogModeConstants = dbmLogModeNone)
    DevSpaceClose False
    DevSpacesReset
    If oDB Is Nothing Then Exit Sub
    lNewLogMode = NewLogMode
    DevSpacesList
End Sub

Public Function Command(ByVal DevSpacesCommand As DBMDocDevSpacesCommands) As Boolean
    Dim bOK As Boolean
    Dim bCancel As Boolean
    
    bOK = True
    
    bCancel = False
    
    RaiseEvent CommandBefore(DevSpacesCommand, bCancel)
    
    If Not bCancel Then
        Select Case DevSpacesCommand
            Case cmdDevSpaceEdit:       DevSpaceEdit
            Case cmdDevSpaceDelete:     DevSpaceDelete
            Case cmdDevSpacesRefresh:   Refresh
        End Select
    Else
        bOK = False
    End If

    RaiseEvent CommandAfter(DevSpacesCommand)
    
    Command = bOK
End Function

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwDevSpaces, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    DevSpaceClose False
    Cancel = False
End Sub

Public Sub Reset()
    docDevSpace.Reset
    
    Set oDB = Nothing
    Set oDevSpaces = Nothing
    Set oDevSpaceOpen = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    lSenderID = GetSenderID()
    
    bAsynchron = True
    
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    Set oDevSpaceOpen = Nothing
    
    lMode = dbmDevSpacesModeDefault
    
    lNewLogMode = dbmLogModeNone
    
    DevSpacesInit
    DevSpacesReset
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwDevSpaces.Move 0, iTop, ScaleWidth, iHeight
    
    docDevSpace.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
    With PropBag
        Mode = .ReadProperty("Mode", dbmDevSpacesModeDefault)
        Asynchron = .ReadProperty("Asynchron", True)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
    With PropBag
        .WriteProperty "Mode", Mode, dbmDevSpacesModeDefault
        .WriteProperty "Asynchron", Asynchron, True
    End With
End Sub
'
' lvwDevSpaces
'
Private Sub lvwDevSpaces_ItemClick(ByVal Item As MSComctlLib.ListItem)
    DevSpacesSelectItem Item, True
End Sub

Private Sub lvwDevSpaces_DblClick()
    If bItemClick Then
        If CML.CommandItems.Item(cmdDevSpaceEdit).Enabled Then
            DevSpaceEdit
        End If
    End If
End Sub

Private Sub lvwDevSpaces_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwDevSpaces.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwDevSpaces_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwDevSpaces.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popDevSpaces
        Else
            POP.Show popDevSpace
        End If
    End If
End Sub

Private Sub lvwDevSpaces_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    If CML.CommandItems.Item(cmdDevSpaceEdit).Enabled Then
                        DevSpaceEdit
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdDevSpacesRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docDevSpace
'
Private Sub docDevSpace_DevSpaceCancel(ByVal DevSpace As DBMLib.DevSpace)
    DevSpaceClose True
    RaiseEvent DevSpaceCancel(DevSpace)
End Sub

Private Sub docDevSpace_DevSpaceOK(ByVal DevSpace As DBMLib.DevSpace)
    Dim oItem As MSComctlLib.ListItem
    
    Set oItem = ListViewUtil.GetListItemByKey(lvwDevSpaces, DevSpace.Name)
    
    If Not oItem Is Nothing Then
        DevSpaceFillItem DevSpace, oItem
        RefreshSysDevSpace
    End If
    
    Set oNextLog = oDB.DevSpaces.NextUnUsedLogDevSpace
    Set oNextData = oDB.DevSpaces.NextUnUsedDataDevSpace
    
    DevSpaceClose True
    
    ListViewUtil.FitColumnSize lvwDevSpaces, True
    
    CommandsSet False
    
    RaiseEvent DevSpaceOK(DevSpace)
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_StateChanged()
    lState = oDB.State.Value
    CommandsSet False
End Sub

Private Sub oDB_DevSpaceAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMLib.DBMDevSpaceActionConstants, ByVal DevSpace As DBMLib.DevSpace)
    If SenderID <> lSenderID Then Exit Sub
    Select Case Action
        Case dbmDevSpaceActionDelete: DevSpaceDeleted DevSpace
    End Select
End Sub

Private Sub oDB_DevSpacesOpen(ByVal SenderID As Long, ByVal Error As Boolean)
    If SenderID <> lSenderID Then Exit Sub
    
    If lMode = dbmDevSpacesModeInit Then
        oDB.DevSpaces.CheckSysDevSpace
    End If
        
    DevSpacesList
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Command Item.Key
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        Set oItem = .Add(cmdTypeSubCommand, cmdDevSpaces, "&Volumes")
        Set oItem = .Add(cmdTypeDefault, cmdDevSpaceEdit, "&Edit", oRes.Bitmap16ID(IDB_16_EDIT))
        Set oItem = .Add(cmdTypeSeperator, cmdDevSpaceDeleteSep)
        Set oItem = .Add(cmdTypeDefault, cmdDevSpaceDelete, "&Delete", oRes.Bitmap16ID(IDB_16_DELETE))
        Set oItem = .Add(cmdTypeSeperator, cmdDevSpacesRefreshSep)
        Set oItem = .Add(cmdTypeDefault, cmdDevSpacesRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH))
        Set oItem = .Add(cmdTypeSeperator, cmdSeperator)
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdDevSpaceEdit)
        Set oItem = .Add(cmdDevSpaceDeleteSep)
        Set oItem = .Add(cmdDevSpaceDelete)
        Set oItem = .Add(cmdDevSpacesRefreshSep)
        Set oItem = .Add(cmdDevSpacesRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdDevSpaces)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdDevSpaceEdit)
        Set oItem = .Add(cmdDevSpaceDeleteSep)
        Set oItem = .Add(cmdDevSpaceDelete)
        Set oItem = .Add(cmdDevSpacesRefreshSep)
        Set oItem = .Add(cmdDevSpacesRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupDevSpacesInit
    PopupDevSpaceInit
End Sub

Private Sub PopupDevSpacesInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdDevSpacesRefresh)
    End With
End Sub

Private Sub PopupDevSpaceInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdDevSpaceEdit)
        Set oItem = .Add(cmdDevSpaceDeleteSep)
        Set oItem = .Add(cmdDevSpaceDelete)
    End With
End Sub

'''

Private Sub CommandsMode()
    With CML.CommandItems
        Select Case lMode
            Case dbmDevSpacesModeDefault, dbmDevSpacesModeData, dbmDevSpacesModeLog:
                .Item(cmdDevSpaceDeleteSep).Visible = True
                .Item(cmdDevSpaceDelete).Visible = True
                .Item(cmdDevSpacesRefreshSep).Visible = True
                .Item(cmdDevSpacesRefresh).Visible = True
                
            Case dbmDevSpacesModeInit:
                .Item(cmdDevSpaceDeleteSep).Visible = True
                .Item(cmdDevSpaceDelete).Visible = True
                .Item(cmdDevSpacesRefreshSep).Visible = False
                .Item(cmdDevSpacesRefresh).Visible = False
                
            Case dbmDevSpacesModeLogMode:
                .Item(cmdDevSpaceDeleteSep).Visible = False
                .Item(cmdDevSpaceDelete).Visible = False
                .Item(cmdDevSpacesRefreshSep).Visible = False
                .Item(cmdDevSpacesRefresh).Visible = False
            
        End Select
    End With
End Sub

Private Sub CommandsSet(ByVal bExecute As Boolean, Optional ByVal bEnabled As Boolean = True)
    Dim oDevSpace As DBMLib.DevSpace
    Dim bEdit As Boolean
    Dim bDelete As Boolean
    
    bRunning = bExecute
    
    With CML.CommandItems
        If bEnabled Then
            If Not bExecute Then
                If oItemAct Is Nothing Then
                    .Item(cmdDevSpaceEdit).Enabled = False
                    .Item(cmdDevSpaceDelete).Enabled = False
                Else
                    Set oDevSpace = oDB.DevSpaces(LVWName(oItemAct.Key))
                    If Not oDevSpace Is Nothing Then
                        bEdit = False
                        bDelete = False
                        
                        Select Case lMode
                        
                            Case dbmDevSpacesModeDefault, dbmDevSpacesModeData, dbmDevSpacesModeLog:
                            
                                If oDevSpace.Exists Then
                                    If lState = dbmDBStateOffline Then
                                        bEdit = True
                                    End If
                                Else
                                    If lState <> dbmDBStateOffline Then
                                        If Not oNextLog Is Nothing Then
                                            If oDevSpace.Name = oNextLog.Name Then
                                                bEdit = True
                                            End If
                                        End If
                                    
                                        If Not oNextData Is Nothing Then
                                            If oDevSpace.Name = oNextData.Name Then
                                                bEdit = True
                                            End If
                                        End If
                                    End If
                                End If
                            
                            Case dbmDevSpacesModeInit:
                            
                                If oDevSpace.Exists Then
                                    bEdit = True
                                    If oDevSpace.DeviceClass <> dbmDSCSys Then
                                        bDelete = True
                                    End If
                                Else
                                    If Not oNextLog Is Nothing Then
                                        If oDevSpace.Name = oNextLog.Name Then
                                            bEdit = True
                                        End If
                                    End If
                                
                                    If Not oNextData Is Nothing Then
                                        If oDevSpace.Name = oNextData.Name Then
                                            bEdit = True
                                        End If
                                    End If
                                End If
                            
                            Case dbmDevSpacesModeLogMode:
                                bEdit = True
                                
                        End Select
                        
                        .Item(cmdDevSpaceEdit).Enabled = bEdit
                        .Item(cmdDevSpaceDelete).Enabled = bDelete
                    Else
                        .Item(cmdDevSpaceEdit).Enabled = False
                        .Item(cmdDevSpaceDelete).Enabled = False
                    End If
                End If
                .Item(cmdDevSpacesRefresh).Enabled = True
            Else
                .Item(cmdDevSpaceEdit).Enabled = False
                .Item(cmdDevSpaceDelete).Enabled = False
                .Item(cmdDevSpacesRefresh).Enabled = False
            End If
        Else
            .Item(cmdDevSpaceEdit).Enabled = False
            .Item(cmdDevSpaceDelete).Enabled = False
            .Item(cmdDevSpacesRefresh).Enabled = False
        End If
    End With

    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub DevSpacesInit()
    lvwDevSpaces.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub DevSpacesSetColumns()
    Dim bMirrored As Boolean
    
    bMirrored = False
    
    lvwDevSpaces.ColumnHeaders.Clear

    With lvwDevSpaces.ColumnHeaders
        .Add , , "Name"
        .Add , , "Size", , lvwColumnRight
        .Add , , "Type"
        .Add , , "Location"
        Select Case lMode
            Case dbmDevSpacesModeDefault, dbmDevSpacesModeInit:
                If oDB.DevSpaces.MirroredData Or _
                   oDB.DevSpaces.MirroredLog _
                Then
                    bMirrored = True
                End If
            Case dbmDevSpacesModeData:
                If oDB.DevSpaces.MirroredData Then
                    bMirrored = True
                End If
            Case dbmDevSpacesModeLog:
                If oDB.DevSpaces.MirroredLog Then
                    bMirrored = True
                End If
            Case dbmDevSpacesModeLogMode:
                bMirrored = True
        End Select
        If bMirrored Then
            .Add , , "Mirrored Location"
            .Add , , "Mirrored Type"
        End If
    End With
End Sub

Private Function DevSpacesRefresh(ByVal bLostQuestion As Boolean) As Boolean
    Dim bOK As Boolean
    Dim bRefresh As Boolean
    
    bOK = False

    If oDB Is Nothing Then
        DevSpacesRefresh = bOK
        Exit Function
    End If
    
    bRefresh = True
    
    If bLostQuestion Then
        If oDevSpaces.Dirty Then
            If MsgBox("All changes in devspaces will be lost!", vbExclamation + vbOKCancel, "Confirm Changes Lost") = vbOK Then
                bRefresh = True
            Else
                bRefresh = False
            End If
        End If
    End If
    
    If bRefresh Then
        DevSpacesReset
        
        CommandsSet True
        
        bOK = oDB.DevSpaces.OpenDevSpaces(bAsynchron, lSenderID)
        
        If Not bAsynchron Then
            oDB_DevSpacesOpen lSenderID, Not bOK
        End If
    Else
        bOK = True
    End If
    
    DevSpacesRefresh = bOK
End Function

Private Sub DevSpacesReset()
    Set oItemAct = Nothing
    lvwDevSpaces.ListItems.Clear
End Sub

Private Sub DevSpacesList()
    Dim oDevSpace As DBMLib.DevSpace
    Dim lCount As Long
    Dim lItem As Long
    Dim oItem As MSComctlLib.ListItem
    
    lState = oDB.State.Value(True)
    
    TIBAt oTIB, At

    DevSpacesSetColumns

    lvwDevSpaces.ListItems.Clear
        
    lCount = oDB.DevSpaces.Count
    For lItem = 1 To lCount
        Set oDevSpace = oDB.DevSpaces.Item(lItem)
        If (lMode = dbmDevSpacesModeData And oDevSpace.DeviceClass = dbmDSCData) Or _
           (lMode = dbmDevSpacesModeData And oDevSpace.DeviceClass = dbmDSCSys) Or _
           (lMode = dbmDevSpacesModeLog And oDevSpace.DeviceClass = dbmDSCLog) Or _
           (lMode = dbmDevSpacesModeLogMode And oDevSpace.DeviceClass = dbmDSCLog And oDevSpace.Exists) Or _
           (lMode = dbmDevSpacesModeDefault) Or _
           (lMode = dbmDevSpacesModeInit) _
        Then
            Set oItem = lvwDevSpaces.ListItems.Add(, LVWKey(oDevSpace.Name), oDevSpace.Name)
            DevSpaceFillItem oDevSpace, oItem
        End If
    Next
    
    If lvwDevSpaces.ListItems.Count > 0 Then
        If lvwDevSpaces.SelectedItem Is Nothing Then
            lvwDevSpaces.SelectedItem = lvwDevSpaces.ListItems(1)
        End If
        DevSpacesSelectItem lvwDevSpaces.SelectedItem
    End If
            
    ListViewUtil.FitColumnSize lvwDevSpaces, True
    
    Set oNextLog = oDB.DevSpaces.NextUnUsedLogDevSpace
    Set oNextData = oDB.DevSpaces.NextUnUsedDataDevSpace
    
    CommandsSet False
End Sub

Private Sub DevSpaceFillItem(oDevSpace As DBMLib.DevSpace, _
                             oItem As MSComctlLib.ListItem)
    Dim lSizeKB As Long
    
    With oItem
        If oDevSpace.Exists Then
            Select Case oDevSpace.DeviceClass
                Case dbmDSCSys:   .SmallIcon = oRes.Bitmap16ID(IDB_16_DEVSPACE_SYS)
                Case dbmDSCData:  .SmallIcon = oRes.Bitmap16ID(IDB_16_DEVSPACE_DATA)
                Case dbmDSCLog:   .SmallIcon = oRes.Bitmap16ID(IDB_16_DEVSPACE_LOG)
            End Select
        Else
            Select Case oDevSpace.DeviceClass
                Case dbmDSCSys:   .SmallIcon = oRes.Bitmap16ID(IDB_16_DEVSPACE_SYS_NE)
                Case dbmDSCData:  .SmallIcon = oRes.Bitmap16ID(IDB_16_DEVSPACE_DATA_NE)
                Case dbmDSCLog:   .SmallIcon = oRes.Bitmap16ID(IDB_16_DEVSPACE_LOG_NE)
            End Select
        End If
            
        If oDevSpace.SizeKB > 0 Then
            .SubItems(dcSize) = Format$(oDevSpace.SizeKB, "#,#") + "KB"
        Else
            .SubItems(dcSize) = ""
        End If
        
        If oDevSpace.DeviceType = dbmDSTUnknown Then
            .SubItems(dcType) = ""
        Else
            .SubItems(dcType) = oDevSpace.DeviceTypeName
        End If
        
        .SubItems(dcLocation) = oDevSpace.Location
        
        If oDevSpace.Mirrored Then
            If lNewLogMode = dbmLogModeSingle Or _
               lNewLogMode = dbmLogModeDemo _
            Then
                .SubItems(dcMType) = "<remove>"
                .SubItems(dcMLocation) = "<remove>"
            Else
                If oDevSpace.MirroredDeviceType = dbmDSTUnknown Then
                    .SubItems(dcMType) = ""
                Else
                    .SubItems(dcMType) = oDevSpace.MirroredDeviceTypeName
                End If
                
                .SubItems(dcMLocation) = oDevSpace.MirroredLocation
            End If
        Else
            If lNewLogMode = dbmLogModeDual Then
                If oDevSpace.MirroredDeviceType = dbmDSTUnknown Then
                    .SubItems(dcMType) = "?"
                Else
                    .SubItems(dcMType) = oDevSpace.MirroredDeviceTypeName
                End If
                
                If Len(oDevSpace.MirroredLocation) = 0 Then
                    .SubItems(dcMLocation) = "?"
                Else
                    .SubItems(dcMLocation) = oDevSpace.MirroredLocation
                End If
            End If
        End If
    End With
End Sub

Private Sub DevSpacesSelectItem(oItem As MSComctlLib.ListItem, _
                                Optional ByVal bFromClick As Boolean = False)
    Dim oDevSpace As DBMLib.DevSpace
    
    Set oItemAct = oItem
    
    Set oDevSpace = Nothing
    
    If Not bFromClick Then
        Set lvwDevSpaces.SelectedItem = oItemAct
    End If
    
    If Not oItemAct Is Nothing Then
        Set oDevSpace = oDB.DevSpaces(LVWName(oItemAct.Key))
        RaiseEvent DevSpaceClick(oDevSpace)
    End If
    
    CommandsSet False
End Sub

Private Sub DevSpaceEdit()
    Dim oItemPre As MSComctlLib.ListItem
    Dim lDefType As DBMLib.DBMDevSpaceTypeConstants
    Dim sDefLocation As String
    Dim lDefSize As Long
    
    Dim lDefMType As DBMLib.DBMDevSpaceTypeConstants
    Dim sDefMLocation As String
    
    Dim lPos As Long
    
    Dim sMsg As String
    
    If oItemAct Is Nothing Then Exit Sub
    
    ' message if open param session
    If oDB.Parameters.IsOpen Then
        sMsg = "You can not add/edit devspaces now, a parameter session is active." + vbCrLf
        sMsg = sMsg + "Close parameter edit mode to add/edit devspaces."
        MsgBox sMsg, vbExclamation, "Parameter Session Is Active"
        Exit Sub
    End If

    ' message if dirty param file
    If lState <> dbmDBStateOffline Then
        If lMode = dbmDevSpacesModeDefault Or _
           lMode = dbmDevSpacesModeData Or _
           lMode = dbmDevSpacesModeLog _
        Then
            If oDB.Parameters.Changed Then
                sMsg = "You can not add devspaces now, the parameter file is changed." + vbCrLf
                sMsg = sMsg + "Stop and then restart database to get the new parameters active."
                MsgBox sMsg, vbExclamation, "Parameter File Is Changed"
                Exit Sub
            End If
        End If
    End If
    
    lDefType = dbmDSTFile
    sDefLocation = ""
    lDefSize = 0
    
    lDefMType = dbmDSTFile
    sDefMLocation = ""
    
    Set oDevSpaceOpen = oDB.DevSpaces(LVWName(oItemAct.Key))
    
    If (Not oDevSpaceOpen.Exists) And _
       (oDevSpaceOpen.Number > 1) And _
       (Len(oDevSpaceOpen.Location) = 0) _
    Then
        Set oItemPre = ListViewUtil.GetListItemByIndex(lvwDevSpaces, oItemAct.Index - 1)
        If Not oItemPre Is Nothing Then
            With oDB.DevSpaces(LVWName(oItemPre.Key))
                If .Exists Then
                    If .DeviceType = dbmDSTUnknown Then
                        lDefType = dbmDSTFile
                    Else
                        lDefType = .DeviceType
                    End If
                    sDefLocation = GetNextLocation(.Location)
                End If
                lDefSize = .SizeKB
            End With
        End If
    Else
        If (Not oDevSpaceOpen.Exists) And _
           (oDevSpaceOpen.Number = 1) And _
           (Len(oDevSpaceOpen.Location) = 0) _
        Then
            sDefLocation = Left$(oDevSpaceOpen.Name, 3) + "_"
            Select Case oDevSpaceOpen.DeviceClass
                Case dbmDSCSys: sDefLocation = "SYS_" & Format$(oDevSpaceOpen.Number, "000")
                Case dbmDSCData: sDefLocation = "DAT_" & Format$(oDevSpaceOpen.Number, "0000")
                Case dbmDSCLog: sDefLocation = "LOG_" & Format$(oDevSpaceOpen.Number, "000")
            End Select
            lDefSize = 0
            lDefType = dbmDSTFile
        End If
    End If
        
    If oDevSpaceOpen.Mirrored Then
        If (Not oDevSpaceOpen.MirroredExists) And _
           (oDevSpaceOpen.Number > 1) And _
           (Len(oDevSpaceOpen.MirroredLocation) = 0) _
        Then
            Set oItemPre = ListViewUtil.GetListItemByIndex(lvwDevSpaces, oItemAct.Index - 1)
            If Not oItemPre Is Nothing Then
                With oDB.DevSpaces(LVWName(oItemPre.Key))
                    If .MirroredExists Then
                        If .MirroredDeviceType = dbmDSTUnknown Then
                            lDefMType = dbmDSTFile
                        Else
                            lDefMType = .MirroredDeviceType
                        End If
                        sDefMLocation = GetNextLocation(.MirroredLocation)
                    End If
                End With
            End If
        Else
            If (Not oDevSpaceOpen.MirroredExists) And _
               (oDevSpaceOpen.Number = 1) And _
               (Len(oDevSpaceOpen.MirroredLocation) = 0) _
            Then
                Select Case oDevSpaceOpen.DeviceClass
                    Case dbmDSCSys: sDefMLocation = "SYS_M_" & Format$(oDevSpaceOpen.Number, "000")
                    Case dbmDSCData: sDefMLocation = "DAT_M_" & Format$(oDevSpaceOpen.Number, "0000")
                    Case dbmDSCLog: sDefMLocation = "LOG_M_" & Format$(oDevSpaceOpen.Number, "000")
                End Select
                lDefMType = dbmDSTFile
            End If
        End If
    End If
    
    With docDevSpace
        Set .Database = oDB
        Set .DevSpace = oDevSpaceOpen
        .DefaultType = lDefType
        .DefaultLocation = sDefLocation
        .DefaultSize = lDefSize
        
        .DefaultMirroredType = lDefMType
        .DefaultMirroredLocation = sDefMLocation
        
        .Refresh

        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwDevSpaces.Visible = False
    
    TIBCaption oTIB, Caption
    
    RaiseEvent DevSpaceEdit(oDevSpaceOpen)
End Sub

Private Sub DevSpaceClose(ByVal bSetFocus As Boolean)
    If Not oDevSpaceOpen Is Nothing Then
        Set oDevSpaceOpen = Nothing
        TIBCaption oTIB, Caption
        docDevSpace.Visible = False
        lvwDevSpaces.Visible = True
        If bSetFocus Then
            lvwDevSpaces.SetFocus
        End If
    End If
End Sub

Private Function GetNextLocation(sLocation As String) As String
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim sPath As String
    Dim sName As String
    Dim sLeft As String
    Dim sRight As String
    Dim sNum As String
    Dim dNum As Double
    Dim sFormat As String
        
    If Len(sLocation) = 0 Then
        GetNextLocation = ""
        Exit Function
    End If
        
    ' get path and name
    lPos1 = Len(sLocation)
    Do While lPos1 > 0
        If Mid$(sLocation, lPos1, 1) = "\" Or _
           Mid$(sLocation, lPos1, 1) = "/" _
        Then
           Exit Do
        End If
        lPos1 = lPos1 - 1
    Loop
    
    If lPos1 > 0 Then
        sPath = Left$(sLocation, lPos1)
        sName = Right$(sLocation, Len(sLocation) - lPos1)
    Else
        sPath = ""
        sName = sLocation
    End If
    
    ' find number part in name
    lPos2 = Len(sName)
    Do While lPos2 > 0
        If Mid$(sName, lPos2, 1) >= "0" And _
           Mid$(sName, lPos2, 1) <= "9" _
        Then
            Exit Do
        End If
        lPos2 = lPos2 - 1
    Loop
    
    If lPos2 > 0 Then
        lPos1 = lPos2 - 1
        Do While lPos1 > 0
            If Mid$(sName, lPos1, 1) < "0" Or _
               Mid$(sName, lPos1, 1) > "9" _
            Then
                Exit Do
            End If
            lPos1 = lPos1 - 1
        Loop
    
        ' increment number
        If (lPos2 - lPos1) > 15 Then
            lPos1 = lPos2 - 15
        End If
        
        sLeft = Left$(sName, lPos1)
        sNum = Mid$(sName, lPos1 + 1, lPos2 - lPos1)
        sRight = Mid$(sName, lPos2 + 1)
    
        If IsNumeric(sNum) Then
            dNum = CDbl(sNum)
            sFormat = String(Len(sNum), "0")
            GetNextLocation = sPath & sLeft + Format$(dNum + 1, sFormat) + sRight
        Else
            GetNextLocation = sLocation + "2"
        End If
    Else
        GetNextLocation = sLocation + "2"
    End If
End Function

Private Sub DevSpaceDelete()
    Dim oDevSpace As DBMLib.DevSpace
    
    If oItemAct Is Nothing Then Exit Sub
    
    Set oDevSpace = oDB.DevSpaces(LVWName(oItemAct.Key))
    
    If Not oDevSpace Is Nothing Then
        If oDevSpace.Delete(True, lSenderID) Then
            CommandsSet True
        End If
    End If
End Sub

Private Sub DevSpaceDeleted(oDevSpace As DBMLib.DevSpace)
    DevSpaceFillItem oDevSpace, oItemAct
    RefreshSysDevSpace
    
    Set oNextLog = oDB.DevSpaces.NextUnUsedLogDevSpace
    Set oNextData = oDB.DevSpaces.NextUnUsedDataDevSpace
    
    RaiseEvent DevSpaceDelete(oDevSpace)
    
    CommandsSet False
End Sub

Private Sub RefreshSysDevSpace()
    Dim oDevSpace As DBMLib.DevSpace
    Dim oItem As MSComctlLib.ListItem
    
    If (lMode = dbmDevSpacesModeData) Or _
       (lMode = dbmDevSpacesModeDefault) Or _
       (lMode = dbmDevSpacesModeInit) _
    Then
        Set oDevSpace = oDB.DevSpaces(1)
        If oDevSpace.DeviceClass = dbmDSCSys Then
            Set oItem = ListViewUtil.GetListItemByKey(lvwDevSpaces, oDevSpace.Name)
            DevSpaceFillItem oDevSpace, oItem
        End If
    End If
End Sub
