VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocFiles 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7065
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   7065
   ToolboxBitmap   =   "DBMDocFiles.ctx":0000
   Begin MSComctlLib.ListView lvwFiles 
      Height          =   1695
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2715
      _ExtentX        =   4789
      _ExtentY        =   2990
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   7
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Type"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   2
         Text            =   "Size"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Modified"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Text            =   "Short Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(6) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   5
         Text            =   "SizeBin"
         Object.Width           =   0
      EndProperty
      BeginProperty ColumnHeader(7) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   6
         Text            =   "ModifiedBin"
         Object.Width           =   0
      EndProperty
   End
   Begin DBMDoc.DBMDocFile docFile 
      Height          =   1815
      Left            =   3600
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   2895
      _ExtentX        =   5106
      _ExtentY        =   3201
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2880
      Top             =   720
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2880
      Top             =   360
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   456
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   3144
      Width           =   7068
      _ExtentX        =   12462
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   2880
      Top             =   1080
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin VB.Menu mnuFiles 
      Caption         =   "Files"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_OFFLINE + DB_STATE_COLD + DB_STATE_WARM

Private Enum FilesCommands
    cmdFiles
    cmdFileView
    cmdFilesRefresh
    cmdSeperator
End Enum

Const CMD_FIRST = cmdFiles
Const CMD_LAST = cmdSeperator

Private Enum FilesPopupConstants
    popFiles = 1
    popFile
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean

'''

Private Enum FilesColumnConstants
    fcName
    fcType
    fcSize
    fcModified
    fcShort
    fcSizeBin
    fcModifiedBin
End Enum

'''

Private oItemAct As MSComctlLib.ListItem
Private bItemClick As Boolean
Private bFitColumnSize As Boolean

Private oFileOpen As DBMLib.File

'''

Public Event WrongDBState()

Public Event FileClick(ByVal File As DBMLib.File)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_FILES
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = "Check - Diagnosis Files"
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(ByVal NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    docFile.ToolBar = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
    Set docFile.TitleBar = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get ProtocolFont() As StdFont
    Set ProtocolFont = docFile.ProtocolFont
End Property
Public Property Set ProtocolFont(ByVal NewVal As StdFont)
    Set docFile.ProtocolFont = NewVal
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    If Not oDB Is Nothing Then
        At = oDB.Files.At
    Else
        At = Empty
    End If
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    FilesRefresh
End Sub

Public Sub ViewList()
    FileClose True
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwFiles, True, 5
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    FileClose False
    Cancel = False
End Sub

Public Sub Reset()
    docFile.Reset
    
    Set oDB = Nothing
    Set oFileOpen = Nothing
End Sub

Public Sub CleanUp()
    docFile.CleanUp
    
    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    Set oFileOpen = Nothing
    
    bFitColumnSize = True
        
    FilesInit
    FilesReset
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwFiles.Move 0, iTop, ScaleWidth, iHeight
    
    docFile.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwFiles
'
Private Sub lvwFiles_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    If ColumnHeader.Index = (fcSize + 1) Then
        ListViewUtil.SortColumn lvwFiles, lvwFiles.ColumnHeaders(fcSizeBin + 1)
    ElseIf ColumnHeader.Index = (fcModified + 1) Then
        ListViewUtil.SortColumn lvwFiles, lvwFiles.ColumnHeaders(fcModifiedBin + 1)
    Else
        ListViewUtil.SortColumn lvwFiles, ColumnHeader
    End If
End Sub

Private Sub lvwFiles_ItemClick(ByVal Item As MSComctlLib.ListItem)
    FilesSelectItem Item
End Sub

Private Sub lvwFiles_DblClick()
    If bItemClick Then FileView
End Sub

Private Sub lvwFiles_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwFiles.HitTest(x, y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub lvwFiles_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwFiles.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popFiles
        Else
            POP.Show popFile
        End If
    End If
End Sub

Private Sub lvwFiles_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyReturn:
                    If CML.CommandItems.Item(cmdFileView).Enabled Then
                        FileView
                    End If
                Case vbKeyF5:
                    If CML.CommandItems.Item(cmdFilesRefresh).Enabled Then
                        Refresh
                    End If
            End Select
    End Select
End Sub
'
' docFile
'
Private Sub docFile_Command(ByVal Command As FileCommands)
    Select Case Command
        Case cmdFileBack:   FileClose True
    End Select
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_FilesOpen(ByVal Error As Boolean)
    FilesList
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdFileView:       FileView
        Case cmdFilesRefresh:   Refresh
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdFiles, "&DiagnosisFiles", 0
        .Add cmdTypeDefault, cmdFileView, "View", oRes.Bitmap16ID(IDB_16_FILE_VIEW)
        .Add cmdTypeDefault, cmdFilesRefresh, "&Refresh", oRes.Bitmap16ID(IDB_16_REFRESH)
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdFileView)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFilesRefresh)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    Dim i As Integer
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdFiles)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdFileView)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFilesRefresh)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupFilesInit
    PopupFileInit
End Sub

Private Sub PopupFilesInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdFilesRefresh)
    End With
End Sub

Private Sub PopupFileInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdFileView)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFilesRefresh)
    End With
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute
    
    With CML.CommandItems
        If Not bExecute Then
            If oItemAct Is Nothing Then
                .Item(cmdFileView).Enabled = False
            Else
                .Item(cmdFileView).Enabled = True
            End If
            .Item(cmdFilesRefresh).Enabled = True
        Else
            .Item(cmdFileView).Enabled = False
            .Item(cmdFilesRefresh).Enabled = False
        End If
    End With

    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub FilesInit()
    lvwFiles.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub FilesRefresh()
    FilesReset
    
    If oDB Is Nothing Then Exit Sub
    
    If oDB.Files.OpenFiles(True) Then
        CommandsSet True
    End If
End Sub

Private Sub FilesReset()
    Set oItemAct = Nothing
    lvwFiles.ListItems.Clear
End Sub

Private Sub FilesList()
    Dim oFile As DBMLib.File
    Dim lCount As Long
    Dim lItem As Long
    Dim oItem As MSComctlLib.ListItem
    Dim lSizeKB As Long
    
    If oDB Is Nothing Then Exit Sub
    
    TIBAt oTIB, At

    lvwFiles.ListItems.Clear
        
    lCount = oDB.Files.Count
    For lItem = 1 To lCount
        Set oFile = oDB.Files.Item(lItem)
        If Left$(oFile.FileTypeString, 1) = "A" Then
            Set oItem = lvwFiles.ListItems.Add(, LVWKey(oFile.Name), oFile.Description, , oRes.Bitmap16ID(IDB_16_FILE))
            oItem.SubItems(fcType) = oFile.FileTypeString
            
            lSizeKB = oFile.Size \ 1024
            If (oFile.Size Mod 1024) > 0 Then
                lSizeKB = lSizeKB + 1
            End If
            oItem.SubItems(fcSize) = Format$(lSizeKB, "#,#") + "KB"
            oItem.SubItems(fcSizeBin) = Format$(lSizeKB, "000000000000000")
            
            oItem.SubItems(fcModified) = oFile.Modified
            oItem.SubItems(fcModifiedBin) = Format$(oFile.Modified, "yyyymmddHhNnSs")
 
            oItem.SubItems(fcShort) = oFile.Name
        End If
    Next
    
    If bFitColumnSize Then
        ListViewUtil.FitColumnSize lvwFiles, True, 5
        bFitColumnSize = False
    End If
    
    Set oItemAct = lvwFiles.SelectedItem
    
    CommandsSet False
End Sub

Private Sub FilesSelectItem(ByVal oItem As MSComctlLib.ListItem)
    Dim oFile As DBMLib.File
    
    Set oItemAct = oItem
    
    Set oFile = Nothing
    Set oFile = oDB.Files(LVWName(oItemAct.Key))
    
    RaiseEvent FileClick(oFile)
    
    CommandsSet False
End Sub

Private Sub FileView()
    If oItemAct Is Nothing Then Exit Sub

    Set oFileOpen = oDB.Files(LVWName(oItemAct.Key))

    With docFile
        Set .Database = oDB
        Set .File = oFileOpen
        .Refresh

        .Visible = True
        .ZOrder 0
        
        .SetFocus
    End With
    
    lvwFiles.Visible = False
End Sub

Private Sub FileClose(ByVal bSetFocus As Boolean)
    If Not oFileOpen Is Nothing Then
        Set oFileOpen = Nothing
        docFile.Visible = False
        lvwFiles.Visible = True
        If bSetFocus Then
            lvwFiles.SetFocus
        End If
        
    End If
    
    TIBAt oTIB, At
End Sub
