VERSION 5.00
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocMapcharSet 
   ClientHeight    =   5520
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7140
   KeyPreview      =   -1  'True
   ScaleHeight     =   5520
   ScaleWidth      =   7140
   ToolboxBitmap   =   "DBMDocMapcharSet.ctx":0000
   Begin VB.PictureBox picGeneral 
      BorderStyle     =   0  'None
      Height          =   3855
      Left            =   60
      ScaleHeight     =   3855
      ScaleWidth      =   3015
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Width           =   3015
      Begin DBMDoc.ctlMapChar ctrMapchar 
         Height          =   2715
         Left            =   60
         TabIndex        =   7
         Top             =   1080
         Width           =   2835
         _ExtentX        =   5001
         _ExtentY        =   4789
      End
      Begin VB.Frame fraType 
         Height          =   495
         Left            =   1080
         TabIndex        =   4
         Top             =   420
         Width           =   1815
         Begin VB.OptionButton optType 
            Caption         =   "EBCDIC"
            Height          =   255
            Index           =   1
            Left            =   840
            TabIndex        =   6
            Top             =   180
            Width           =   915
         End
         Begin VB.OptionButton optType 
            Caption         =   "ASCII"
            Height          =   252
            Index           =   0
            Left            =   60
            TabIndex        =   5
            Top             =   180
            Width           =   735
         End
      End
      Begin VB.TextBox txtName 
         BorderStyle     =   0  'None
         Height          =   255
         Left            =   1080
         TabIndex        =   2
         Top             =   120
         Width           =   1815
      End
      Begin VB.Label lblType 
         Caption         =   "Code Type:"
         Height          =   195
         Left            =   60
         TabIndex        =   3
         Top             =   600
         Width           =   945
      End
      Begin VB.Label lbName 
         Caption         =   "&Name:"
         Height          =   195
         Left            =   60
         TabIndex        =   1
         Top             =   120
         Width           =   705
      End
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   3840
      Top             =   540
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   3840
      Top             =   180
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   5070
      Width           =   7140
      _ExtentX        =   12594
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin VB.Menu mnuMapcharSet 
      Caption         =   "MapcharSet"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocMapcharSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_WARM

Const ERR_SAVEMAPCHARS = "Error while saving mapchar set!"

Public Enum MapcharSetCommands
    cmdMapcharSet
    cmdMapcharSetOK
    cmdMapcharSetCancel
    cmdSeperator
End Enum

Const CMD_FIRST = cmdMapcharSet
Const CMD_LAST = cmdSeperator

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean
Private oMapcharSet As DBMLib.MapcharSet
Private oCopyFromMapcharSet As DBMLib.MapcharSet

Private bDirty As Boolean

'''

Public Event WrongDBState()

Public Event MapcharSetCreated(ByVal MapcharSet As DBMLib.MapcharSet)
Public Event MapcharSetChanged(ByVal MapcharSet As DBMLib.MapcharSet)
Public Event Command(ByVal Command As MapcharSetCommands)

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_MAPCHARSETS
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = RS(IDS_G_CONFIG) + " - " + RS(IDS_G6_MAPCHARSET)
    If Not oDB Is Nothing Then
        s = s + " - " + oDB.Name
        If Not oMapcharSet Is Nothing Then
            s = s + " - " + oMapcharSet.Name
        End If
    End If
    Caption = s
End Property

Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Set MapcharSet(ByVal NewVal As DBMLib.MapcharSet)
    Set oMapcharSet = NewVal
End Property

Public Property Set CopyFromMapcharSet(ByVal NewVal As DBMLib.MapcharSet)
    Set oCopyFromMapcharSet = NewVal
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    UserControl.MousePointer = vbHourglass
    FillForm
    UserControl.MousePointer = vbDefault
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
    Set oMapcharSet = Nothing
    Set oCopyFromMapcharSet = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    Set oDB = Nothing
    Set oMapcharSet = Nothing
    Set oCopyFromMapcharSet = Nothing
    
    optType(0).Tag = DBMLib.MapcharCodeTypeConstants.dbmMapcharCodeTypeASCII
    optType(1).Tag = DBMLib.MapcharCodeTypeConstants.dbmMapcharCodeTypeEBCDIC
    
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    picGeneral.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyEscape:
                    If CML.CommandItems.Item(cmdMapcharSetCancel).Enabled Then
                        MapcharSetBack
                    End If
            End Select
    End Select
End Sub
'
' picGeneral
'
Private Sub picGeneral_Resize()
    Dim iHeight As Integer
    
    iHeight = picGeneral.ScaleHeight - ctrMapchar.Top - 2 * iDY
    If iHeight < 0 Then iHeight = 0
    ctrMapchar.Height = iHeight
    ctrMapchar.Width = picGeneral.ScaleWidth
End Sub
'
' txtName
'
Private Sub txtName_Change()
    SetForm
End Sub

Private Sub txtName_GotFocus()
    txtName.SelStart = 0
    txtName.SelLength = Len(txtName.Text)
End Sub
'
' optType
'
Private Sub optType_Click(Index As Integer)
    fraType.Tag = optType(Index).Tag
    
    If Not oMapcharSet Is Nothing Then
        If fraType.Tag <> oMapcharSet.CodeType Then
            bDirty = True
        End If
    End If
    
    SetForm
End Sub
'
' ctrMapchar
'
Private Sub ctrMapchar_Change()
    bDirty = True
    SetForm
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdMapcharSetCancel:   MapcharSetBack
        Case cmdMapcharSetOK:       MapcharSetSave
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdMapcharSet, "&MapcharSet"
        .Add cmdTypeDefault, cmdMapcharSetOK, "&Save", oRes.Bitmap16ID(IDB_16_OK)
        .Add cmdTypeDefault, cmdMapcharSetCancel, "&Cancel", oRes.Bitmap16ID(IDB_16_CANCEL)
        
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdMapcharSetOK)
        Set oItem = .Add(cmdMapcharSetCancel)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oSubSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdMapcharSet)
    End With
    
    With oSub.MenuBarItems
        Set oItem = .Add(cmdMapcharSetOK)
        Set oItem = .Add(cmdMapcharSetCancel)
    End With
End Sub

'''

Private Sub ClearForm()
    bDirty = False
    txtName.Text = ""
    optType(0).Value = True
    ctrMapchar.Grid_Clear
End Sub

Private Sub FillForm()
    ClearForm
    
    If oMapcharSet Is Nothing Then
        txtName.Text = ""
        txtName.BackColor = vbWindowBackground
        txtName.Locked = False
        
        If Not oCopyFromMapcharSet Is Nothing Then
            With oCopyFromMapcharSet
                Select Case .CodeType
                    Case dbmMapcharCodeTypeASCII:  optType(0).Value = True
                    Case dbmMapcharCodeTypeEBCDIC: optType(1).Value = True
                End Select
                ctrMapchar.Grid_Setup oCopyFromMapcharSet
            End With
            bDirty = True
        End If
    Else
        With oMapcharSet
            txtName.Text = .Name
            txtName.BackColor = vbButtonFace
            txtName.Locked = True
            
            Select Case .CodeType
                Case dbmMapcharCodeTypeASCII:  optType(0).Value = True
                Case dbmMapcharCodeTypeEBCDIC: optType(1).Value = True
            End Select
            
            ctrMapchar.Grid_Setup oMapcharSet
        End With
    End If
    
    SetForm
End Sub

Private Sub MapcharSetBack()
    RaiseEvent Command(cmdMapcharSetCancel)
End Sub

Private Sub MapcharSetSave()
    Dim bCreated As Boolean
    Dim bChanged As Boolean
    Dim sName As String
    Dim lType As DBMLib.MapcharCodeTypeConstants
    
    bCreated = False
    bChanged = False
    
    sName = Trim(txtName.Text)
    lType = fraType.Tag
    
    If Not oMapcharSet Is Nothing Then
        bChanged = True
    Else
        Set oMapcharSet = oDB.MapcharSets.AddNewSet(sName)
        bCreated = True
    End If
    
    With oMapcharSet
        .Name = sName
        .CodeType = lType
    End With
    ctrMapchar.Grid_PutMapchars oMapcharSet
    
    If Not oMapcharSet.Save() Then
        MsgBox ERR_SAVEMAPCHARS + vbCrLf + vbCrLf + "(" + Trim(oDB.LastError.Text) + ")", vbExclamation
    Else
        If bCreated Then RaiseEvent MapcharSetCreated(oMapcharSet)
        If bChanged Then RaiseEvent MapcharSetChanged(oMapcharSet)
    End If
    
    RaiseEvent Command(cmdMapcharSetOK)
End Sub


Private Sub SetForm()
    Dim bSave As Boolean
    
    bSave = False
    
    If Len(Trim(txtName.Text)) > 0 And bDirty Then
        bSave = True
    End If
    
    CML.CommandItems.Item(cmdMapcharSetOK).Enabled = bSave
End Sub



