VERSION 5.00
Object = "{BAA397ED-F377-11D4-B32D-0050DADEFE1A}#1.1#0"; "DBMDrt.ocx"
Begin VB.Form frmKernelTraceLevel 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Select the Trace Level"
   ClientHeight    =   2610
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4830
   Icon            =   "KernelTraceLevel.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2610
   ScaleWidth      =   4830
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin DBMDrt.DrawText drtInfo 
      Height          =   195
      Left            =   960
      Top             =   240
      Width           =   3675
      _ExtentX        =   6482
      _ExtentY        =   344
      Caption         =   "?"
   End
   Begin VB.Frame fraLevel 
      Caption         =   "&Trace Level:"
      Height          =   1275
      Left            =   960
      TabIndex        =   0
      Top             =   660
      Width           =   3735
      Begin VB.OptionButton optLevel 
         Caption         =   "&9"
         Height          =   195
         Index           =   8
         Left            =   2340
         TabIndex        =   9
         Top             =   900
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&8"
         Height          =   195
         Index           =   7
         Left            =   1620
         TabIndex        =   8
         Top             =   900
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&7"
         Height          =   195
         Index           =   6
         Left            =   900
         TabIndex        =   7
         Top             =   900
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&6"
         Height          =   195
         Index           =   5
         Left            =   180
         TabIndex        =   6
         Top             =   900
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&5"
         Height          =   195
         Index           =   4
         Left            =   180
         TabIndex        =   5
         Top             =   600
         Value           =   -1  'True
         Width           =   435
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&4"
         Height          =   195
         Index           =   3
         Left            =   2340
         TabIndex        =   4
         Top             =   300
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&3"
         Height          =   195
         Index           =   2
         Left            =   1620
         TabIndex        =   3
         Top             =   300
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&2"
         Height          =   195
         Index           =   1
         Left            =   900
         TabIndex        =   2
         Top             =   300
         Width           =   615
      End
      Begin VB.OptionButton optLevel 
         Caption         =   "&1"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   1
         Top             =   300
         Width           =   615
      End
      Begin VB.Label lblDefault 
         Caption         =   "(Default)"
         Height          =   195
         Left            =   660
         TabIndex        =   10
         Top             =   600
         Width           =   2295
      End
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2280
      TabIndex        =   11
      Top             =   2100
      Width           =   1155
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3540
      TabIndex        =   12
      Top             =   2100
      Width           =   1155
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   180
      Picture         =   "KernelTraceLevel.frx":000C
      Top             =   300
      Width           =   480
   End
End
Attribute VB_Name = "frmKernelTraceLevel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lCommand As Long

Public Function TraceLevel(ByVal sInfo As String, sLevel As String) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    lCommand = vbCancel
    
    drtInfo.Caption = sInfo
    
    fraLevel.Top = drtInfo.Top + drtInfo.Height + 120
    cmdOK.Top = fraLevel.Top + fraLevel.Height + 120
    cmdCancel.Top = cmdOK.Top
    
    Height = cmdOK.Top + cmdOK.Height + 120 + (Height - ScaleHeight)
    
    Me.Show vbModal
    
    Select Case lCommand
        Case vbOK:
            sLevel = fraLevel.Tag
            bOK = True
        Case vbCancel:
            sLevel = ""
            bOK = False
    End Select
    
    Unload Me
    
    TraceLevel = bOK
End Function

Private Sub Form_Load()
    fraLevel.Tag = "5"
End Sub

Private Sub cmdCancel_Click()
    lCommand = vbCancel
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    lCommand = vbOK
    Me.Hide
End Sub

Private Sub optLevel_Click(Index As Integer)
    fraLevel.Tag = CStr(Index + 1)
End Sub
