VERSION 5.00
Begin VB.Form frmCommError 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Communication Error"
   ClientHeight    =   1680
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4590
   Icon            =   "CommError.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1680
   ScaleWidth      =   4590
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdUnregister 
      Caption         =   "&Unregister"
      Height          =   375
      Left            =   2160
      TabIndex        =   2
      Top             =   1200
      Width           =   1095
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   3
      Top             =   1200
      Width           =   1095
   End
   Begin VB.CommandButton cmdReconnect 
      Caption         =   "&Reconnect"
      Default         =   -1  'True
      Height          =   375
      Left            =   960
      TabIndex        =   1
      Top             =   1200
      Width           =   1095
   End
   Begin VB.Label lblInfo 
      Caption         =   "The communication to the DBM-Server was broken"
      Height          =   855
      Left            =   960
      TabIndex        =   0
      Top             =   180
      Width           =   3495
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   180
      Picture         =   "CommError.frx":000C
      Top             =   180
      Width           =   480
   End
End
Attribute VB_Name = "frmCommError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Enum CommandConstants
    cmdCancel
    cmdReconnect
    cmdUnregister
End Enum

'''

Private lCommand As CommandConstants

'''

Public Function CommError(ByVal Name As String, _
                          ByVal Server As String, _
                          ByVal Database As String) As Long
    Dim s As String
    
    lCommand = cmdCancel
    
    Me.Caption = "Reconnect/Unregister database '" & Name & "'?"
    
    s = ""
    s = s + "The communication to the DBM-Server was broken. "
    s = s + "Choose Reconnect to try reconnect to '" + Database + "'"
    If Len(Server) > 0 Then
        s = s + " on server '" + Server + "'. "
    Else
        s = s + ". "
    End If
    s = s + "Choose Unregister to unregister the instance."
    
    lblInfo.Caption = s
    
    Me.Show vbModal
    
    Unload Me
    
    CommError = lCommand
End Function

Private Sub cmdCancel_Click()
    lCommand = cmdCancel
    Me.Hide
End Sub

Private Sub cmdReconnect_Click()
    lCommand = cmdReconnect
    Me.Hide
End Sub

Private Sub cmdUnregister_Click()
    lCommand = cmdUnregister
    Me.Hide
End Sub

