VERSION 5.00
Begin VB.Form frmConnect 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Database Manager Connect"
   ClientHeight    =   3180
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4155
   Icon            =   "Connect.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3180
   ScaleWidth      =   4155
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame fraUser 
      Caption         =   "Database Manager Operator:"
      Height          =   1395
      Left            =   60
      TabIndex        =   5
      Top             =   1680
      Width           =   2775
      Begin VB.TextBox txtPassword 
         BorderStyle     =   0  'None
         Height          =   225
         IMEMode         =   3  'DISABLE
         Left            =   1140
         PasswordChar    =   "*"
         TabIndex        =   9
         Top             =   840
         Width           =   1440
      End
      Begin VB.TextBox txtUser 
         BorderStyle     =   0  'None
         Height          =   225
         Left            =   1140
         TabIndex        =   7
         Top             =   480
         Width           =   1440
      End
      Begin VB.Label lblPassowrd 
         Caption         =   "&Password:"
         Height          =   195
         Left            =   240
         TabIndex        =   8
         Top             =   840
         Width           =   855
      End
      Begin VB.Label lblUser 
         Caption         =   "&User Name:"
         Height          =   195
         Left            =   240
         TabIndex        =   6
         Top             =   480
         Width           =   855
      End
   End
   Begin VB.Frame fraDatabase 
      Caption         =   "Connect to database:"
      Height          =   1395
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2775
      Begin VB.TextBox txtDatabase 
         BorderStyle     =   0  'None
         Height          =   225
         Left            =   1140
         TabIndex        =   4
         Top             =   780
         Width           =   1440
      End
      Begin VB.TextBox txtServer 
         BorderStyle     =   0  'None
         Height          =   225
         Left            =   1140
         TabIndex        =   2
         Top             =   420
         Width           =   1440
      End
      Begin VB.Label lblDatabase 
         Caption         =   "&Database:"
         Height          =   195
         Left            =   240
         TabIndex        =   3
         Top             =   780
         Width           =   795
      End
      Begin VB.Label lblServer 
         Caption         =   "&Server:"
         Height          =   195
         Left            =   240
         TabIndex        =   1
         Top             =   420
         Width           =   795
      End
   End
   Begin VB.CommandButton cmdAdvanced 
      Caption         =   "&Advanced..."
      Enabled         =   0   'False
      Height          =   375
      Left            =   2940
      TabIndex        =   12
      Top             =   2700
      Width           =   1155
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2940
      TabIndex        =   11
      Top             =   600
      Width           =   1155
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2940
      TabIndex        =   10
      Top             =   120
      Width           =   1155
   End
End
Attribute VB_Name = "frmConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lCommand As Long

Private bFirst As Boolean
Private oFocus As Object


Public Function Options(Server As String, _
                        Database As String, _
                        User As String, _
                        Password As String) As Boolean
    Dim bCancel As Boolean
                        
    bCancel = False
    
    txtServer.Text = Server
    txtDatabase.Text = Database
    txtUser.Text = User
    txtPassword.Text = Password
    
    EnabledOK
   
    If Len(Database) = 0 Then
        If Len(Server) = 0 Then
            Set oFocus = txtServer
        End If
    Else
        If Len(User) = 0 Then
            Set oFocus = txtUser
        Else
            If Len(Password) = 0 Then
                Set oFocus = txtPassword
            Else
                Set oFocus = cmdOK
            End If
        End If
    End If
   
    Me.Show vbModal
    
    Select Case lCommand
        Case vbOK:
            Server = Trim$(txtServer.Text)
            Database = Trim$(txtDatabase.Text)
            User = Trim$(txtUser.Text)
            Password = Trim$(txtPassword.Text)
            bCancel = False
            
        Case vbCancel:
            bCancel = True
    End Select
    
    Options = Not bCancel
    
    Unload Me
End Function

Private Sub cmdCancel_Click()
    lCommand = vbCancel
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    lCommand = vbOK
    Me.Hide
End Sub

Private Sub Form_Load()
    bFirst = True
End Sub

Private Sub Form_Paint()
    If bFirst Then
        If Not oFocus Is Nothing Then
            oFocus.SetFocus
        End If
        bFirst = False
    End If
End Sub

Private Sub txtServer_Change()
    EnabledOK
End Sub
Private Sub txtServer_GotFocus()
    txtServer.SelStart = 0
    txtServer.SelLength = Len(txtServer.Text)
End Sub

Private Sub txtDatabase_Change()
    EnabledOK
End Sub
Private Sub txtDatabase_GotFocus()
    txtDatabase.SelStart = 0
    txtDatabase.SelLength = Len(txtDatabase.Text)
End Sub

Private Sub txtUser_Change()
    EnabledOK
End Sub
Private Sub txtUser_GotFocus()
    txtUser.SelStart = 0
    txtUser.SelLength = Len(txtUser.Text)
End Sub

Private Sub txtPassword_Change()
    EnabledOK
End Sub
Private Sub txtPassword_GotFocus()
    txtPassword.SelStart = 0
    txtPassword.SelLength = Len(txtPassword.Text)
End Sub

'''

Private Sub EnabledOK()
    cmdOK.Enabled = (Len(Trim$(txtDatabase.Text)) > 0 And _
                     Len(Trim$(txtUser.Text)) > 0 And _
                     Len(Trim$(txtPassword.Text)) > 0)
End Sub
