VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form frmDocuments 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "List of Windows"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6645
   Icon            =   "Documents.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   6645
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin MSComctlLib.ListView lvwDocuments 
      Height          =   2955
      Left            =   60
      TabIndex        =   3
      Top             =   120
      Width           =   5235
      _ExtentX        =   9234
      _ExtentY        =   5212
      View            =   3
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Document"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Enabled         =   0   'False
      Height          =   345
      Left            =   5400
      TabIndex        =   1
      Top             =   540
      Width           =   1125
   End
   Begin VB.CommandButton cmdShow 
      Caption         =   "&Show"
      Enabled         =   0   'False
      Height          =   345
      Left            =   5400
      TabIndex        =   0
      Top             =   120
      Width           =   1125
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   5400
      TabIndex        =   2
      Top             =   2760
      Width           =   1125
   End
End
Attribute VB_Name = "frmDocuments"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Enum DocumentsColumnConstants
    dcName
    dcDoc
End Enum

Private bItemClick As Boolean

Private Sub Form_Load()
    DocumentsInit
    DocumentsList
End Sub

Private Sub lvwDocuments_ItemClick(ByVal Item As MSComctlLib.ListItem)
    Dim iItem As Integer
    Dim iSelected As Integer
    
    iSelected = 0
    For iItem = 1 To lvwDocuments.ListItems.Count
        If lvwDocuments.ListItems(iItem).Selected Then
            iSelected = iSelected + 1
            If iSelected > 1 Then Exit For
        End If
    Next
    
    cmdShow.Enabled = (iSelected = 1)
End Sub

Private Sub lvwDocuments_DblClick()
    Dim oItem As MSComctlLib.ListItem
    If bItemClick Then
        Set oItem = lvwDocuments.SelectedItem
        If Not oItem Is Nothing Then
            DOCS.ShowByIndex oItem.Index
        End If
        Unload Me
    End If
End Sub

Private Sub lvwDocuments_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwDocuments.HitTest(X, Y)
    bItemClick = Not oItem Is Nothing
End Sub

Private Sub cmdShow_Click()
    Dim oItem As MSComctlLib.ListItem
    Set oItem = lvwDocuments.SelectedItem
    If Not oItem Is Nothing Then
        DOCS.ShowByIndex oItem.Index
    End If
    Unload Me
End Sub

Private Sub cmdClose_Click()
    Dim oItem As MSComctlLib.ListItem
    Dim bCancel As Boolean

    For Each oItem In lvwDocuments.ListItems
        If oItem.Selected Then
            DOCS.Item(oItem.Index).HideFlag = True
        End If
    Next

    DOCS.HideByFlag bCancel, dbmCloseModeDefault
    
    DocumentsList
End Sub

Private Sub cmdOK_Click()
    Unload Me
End Sub

'''

Private Sub DocumentsInit()
    lvwDocuments.SmallIcons = RES.Bitmaps16
End Sub

Private Sub DocumentsList()
    Dim oDoc As Document
    Dim oItem As MSComctlLib.ListItem
    
    lvwDocuments.ListItems.Clear
    
    For Each oDoc In DOCS
        Set oItem = lvwDocuments.ListItems.Add(, , oDoc.Database.Name, , RES.Bitmap16ID(oDoc.Control.PictureID))
        oItem.SubItems(dcDoc) = oDoc.Control.Caption
    Next

    If lvwDocuments.ListItems.Count > 0 Then
        cmdShow.Enabled = True
        cmdClose.Enabled = True
    Else
        cmdShow.Enabled = False
        cmdClose.Enabled = False
    End If
    
    ListViewUtil.FitColumnSize lvwDocuments, True
End Sub
