VERSION 5.00
Begin VB.Form frmSplash 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3720
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   5925
   ControlBox      =   0   'False
   Icon            =   "Splash.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   248
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   395
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer timSplash 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   5460
      Top             =   3240
   End
   Begin VB.Label lblCompany 
      BackColor       =   &H00FFFFFF&
      Caption         =   "SAP DB"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00663300&
      Height          =   375
      Left            =   2460
      TabIndex        =   2
      Top             =   1920
      Width           =   3375
   End
   Begin VB.Label lblTitle 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Database Manager 7.3"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00663300&
      Height          =   375
      Left            =   2460
      TabIndex        =   1
      Top             =   2340
      Width           =   3375
   End
   Begin VB.Image imgSAPDB 
      Height          =   1590
      Left            =   2400
      Top             =   60
      Width           =   3405
   End
   Begin VB.Label lblCopy 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Copyright  1998-2002 by SAP AG"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00663300&
      Height          =   195
      Left            =   2400
      TabIndex        =   0
      Top             =   3420
      Width           =   2835
   End
   Begin VB.Image imgLogo 
      Height          =   3570
      Left            =   60
      Top             =   60
      Width           =   2205
   End
End
Attribute VB_Name = "frmSplash"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function GetDeviceCaps Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal nIndex As Long) As Long
    
Const BITSPIXEL = 12

'''

Private Declare Function SetWindowPos Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) As Long

Const HWND_TOP = 0
Const HWND_BOTTOM = 1
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2

'''

Const LBL_COMPANY = 0
Const LBL_PRODUCT1 = 1
Const LBL_PRODUCT2 = 2
Const LBL_APPNAME = 3
Const LBL_VERSION = 4
Const LBL_COPY = 5

'''

Public Delay As Long
Public AllwaysOnTop As Boolean
Public OnClickClose As Boolean

Private pVersion        As String

'''

Private Sub Form_Load()
    Set imgLogo.Picture = RES.ImageLogo
    imgLogo.Stretch = True
    Set imgSAPDB.Picture = RES.ImageSAP
    
    lblTitle = TXT_TITLE
    lblCopy = TXT_COPYRIGHT
End Sub

Private Sub picSplash_Click()
    If OnClickClose Then
        timSplash.Enabled = False
        Unload Me
    End If
End Sub

Private Sub Form_Resize()
    Dim iWidth As Integer
    Dim iHeight As Integer
    
    iWidth = imgSAPDB.Left - 17
    If iWidth < 0 Then iWidth = 0
    
    iHeight = ScaleHeight - 8
    If iHeight < 0 Then iHeight = 0
    
    imgLogo.Move 4, 4, iWidth, iHeight
End Sub

Private Sub timSplash_Timer()
    timSplash.Enabled = False
    Unload Me
End Sub
