VERSION 5.00
Begin VB.Form frmCommandLineHelp 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Command Line Arguements"
   ClientHeight    =   3540
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6570
   Icon            =   "CommandLineHelp.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3540
   ScaleWidth      =   6570
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   375
      Left            =   2700
      TabIndex        =   5
      Top             =   3060
      Width           =   1155
   End
   Begin VB.Frame fraOptions 
      BackColor       =   &H00000080&
      Caption         =   "Options"
      Height          =   2235
      Left            =   180
      TabIndex        =   2
      Top             =   660
      Width           =   6195
      Begin VB.Label lblDescription 
         Caption         =   "Show command line options."
         Height          =   195
         Index           =   0
         Left            =   1500
         TabIndex        =   4
         Top             =   360
         Width           =   4515
      End
      Begin VB.Label lblName 
         Caption         =   "/?"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.Label lblCmdLineArgs 
      Caption         =   "[/?]"
      Height          =   435
      Left            =   1440
      TabIndex        =   1
      Top             =   120
      Width           =   4875
   End
   Begin VB.Label lblExeName 
      Caption         =   "ExeName[.exe]"
      Height          =   195
      Left            =   180
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmCommandLineHelp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oCommandLine As clsCommandLine

Public Property Set CommandLine(NewVal As clsCommandLine)
    Set oCommandLine = NewVal
End Property

Private Sub Form_Load()
    Dim sCmdLineArgs As String
    Dim oCmdLineArg As clsCommandLineArgument
    Dim l As Long
    
    fraOptions.BackColor = vbButtonFace

    lblExeName.Caption = App.EXEName & ".[exe]"
    
    sCmdLineArgs = ""
    For Each oCmdLineArg In oCommandLine
        With oCmdLineArg
            If .IsOptional Then sCmdLineArgs = sCmdLineArgs & "["
            sCmdLineArgs = sCmdLineArgs & .PrefixString
            sCmdLineArgs = sCmdLineArgs & .Name
            If .ValueDesc <> "" Then
                sCmdLineArgs = sCmdLineArgs & " "
                sCmdLineArgs = sCmdLineArgs & "<" & .ValueDesc & ">"
            End If
            If .IsOptional Then sCmdLineArgs = sCmdLineArgs & "]"
            sCmdLineArgs = sCmdLineArgs & " "
        End With
    Next
            
    For l = 0 To oCommandLine.Count - 1
        If l > 0 Then
            Load lblName(l)
            lblName(l).Move lblName(l - 1).Left, lblName(l - 1).Top + lblName(l - 1).Height
            lblName(l).Visible = True
            Load lblDescription(l)
            lblDescription(l).Move lblDescription(l - 1).Left, lblDescription(l - 1).Top + lblDescription(l - 1).Height
            lblDescription(l).Visible = True
        End If
        With oCommandLine.Item(l + 1)
            If .ValueDesc = "" Then
                lblName(l).Caption = .PrefixString & .Name
            Else
                lblName(l).Caption = .PrefixString & .Name & " <" & .ValueDesc & ">"
            End If
            lblDescription(l).Caption = .Description
        End With
    Next
            
    lblCmdLineArgs.Caption = sCmdLineArgs
End Sub

Private Sub cmdOK_Click()
    Unload Me
End Sub




