Attribute VB_Name = "modGlobal"
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const CML_ARG_HELP = "?"
Const CML_ARG_REG = "R"
Const CML_ARG_UNREG = "U"
Const CML_ARG_CLOSE = "C"

Private oCML As New clsCommandLine

Sub Main()
    If Not CommandLine() Then Exit Sub
    
    frmDBMIns.show

    DoEvents
    
    If oCML.Item(CML_ARG_REG).Exists Then
        frmDBMIns.Register
        If oCML.Item(CML_ARG_CLOSE).Exists Then
            Unload frmDBMIns
        End If
    End If
    
    If oCML.Item(CML_ARG_UNREG).Exists Then
        frmDBMIns.Unregister
        If oCML.Item(CML_ARG_CLOSE).Exists Then
            Unload frmDBMIns
        End If
    End If
End Sub

'''

Private Function CommandLine() As Boolean
    CommandLine = True
    
    With oCML
        .Add cmlPrefixSLASH, CML_ARG_HELP, True, "", "Show command line options."
        .Add cmlPrefixSLASH, CML_ARG_REG, True, "", "Register components."
        .Add cmlPrefixSLASH, CML_ARG_UNREG, True, "", "Unregister Components."
        .Add cmlPrefixSLASH, CML_ARG_CLOSE, True, "", "Close window after action."
    End With
    
    oCML.Text = Command()
    
    If oCML.Item(CML_ARG_HELP).Exists Then
        Set frmCommandLineHelp.CommandLine = oCML
        frmCommandLineHelp.show vbModal
        CommandLine = False
    End If
End Function


