VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QueueItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oExecuteObject As Object
Private sFunctionName As String
Private lSenderID As Long

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTQueueItem
End Property

'''

Public Property Get ExecuteObject() As Object
    Set ExecuteObject = oExecuteObject
End Property
Public Property Set ExecuteObject(NewVal As Object)
    Set oExecuteObject = NewVal
End Property

Public Property Get FunctionName() As String
    FunctionName = sFunctionName
End Property
Public Property Let FunctionName(NewVal As String)
    sFunctionName = NewVal
End Property

Public Property Get SenderID() As Long
    SenderID = lSenderID
End Property
Public Property Let SenderID(ByVal NewVal As Long)
    lSenderID = NewVal
End Property

'''

Public Function Execute() As Boolean
    If Not oExecuteObject Is Nothing Then
        Execute = oExecuteObject.Execute(sFunctionName, True, lSenderID)
    End If
End Function

Public Sub CleanUp()
    Set oExecuteObject = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    Set oExecuteObject = Nothing
    FunctionName = ""
    SenderID = 0
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub








