VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Resource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const SAP_BLUE = &H3366
Const SAP_GREY = &H999999

'''

Const BACKCOLOR_DEFAULT = &HFFFFFF
Const BACKCOLOR_MASK = &HFF00FF

'''

Public Enum Bitmap16ResourceIDConstants
    IDB_16_EMPTY = 1
    IDB_16_NEW
    IDB_16_FOLDER_OPEN
    IDB_16_FOLDER_NEW
    IDB_16_FOLDER_CLOSED
    IDB_16_VIEW_SMALL
    IDB_16_VIEW_LARGE
    IDB_16_VIEW_LIST
    IDB_16_VIEW_DETAILS
    IDB_16_WEB_REFRESH
    IDB_16_WEB_NEXT
    IDB_16_WEB_PREV
    IDB_16_WEB_HOME
    IDB_16_DB
    IDB_16_DB_COLD
    IDB_16_DB_WHITE
    IDB_16_BALL_GREY
    IDB_16_DB_UNKOWN
    IDB_16_DB_WARM
    IDB_16_DB_NOTEXISTS
    IDB_16_DB_OFFLINE
    IDB_16_DB_WAIT
    IDB_16_DB_GREY
    IDB_16_BACKUP_MT_TAPE
    IDB_16_BACKUP_MT_PIPE
    IDB_16_BACKUP_MT_FILE
    IDB_16_BACKUP_ST_PAGES
    IDB_16_BACKUP_ST_LOG
    IDB_16_BACKUP_ST_DATA
    IDB_16_BACKUP_MT_UNKNOWN
    IDB_16_BACKUP_ST_UNKNOWN
    IDB_16_DELETE
    IDB_16_CUT
    IDB_16_COPY
    IDB_16_PASTE
    IDB_16_REFRESH
    IDB_16_FOLDER_UP
    IDB_16_EDIT
    IDB_16_PROPERTIES
    IDB_16_BACKUP_MEDIAGROUP
    IDB_16_BACKUP_MEDIUM_NEW
    IDB_16_BACKUP_MEDIAGROUP_NEW
    IDB_16_BACKUP_SAVE
    IDB_16_BACKUP_RESTORE
    IDB_16_FILE_SAVE
    IDB_16_FILE_OPEN
    IDB_16_AUTOLOG_ON
    IDB_16_AUTOLOG_OFF
    IDB_16_DB_REGISTERED
    IDB_16_DB_WIZARD
    IDB_16_DB_REGISTER
    IDB_16_DB_RESTART
    IDB_16_DB_SHUTDOWN
    IDB_16_BALL_YELLOW
    IDB_16_BALL_RED
    IDB_16_BALL_GREEN
    IDB_16_ABOUT
    IDB_16_HELP_SEARCH
    IDB_16_INFOS
    IDB_16_BACKUP_HISTORY
    IDB_16_BACKUP
    IDB_16_BACKUP_MEDIA
    IDB_16_UNDO
    IDB_16_REDO
    IDB_16_PRINT
    IDB_16_SMALL_ARROW_RIGHT
    IDB_16_SMALL_CHECK
    IDB_16_SMALL_ARROW_LEFT
    IDB_16_NONE
    IDB_16_DIAG_KNLTRACE
    IDB_16_DIAG_KNLTRACEON
    IDB_16_DIAG_KNLTRACEFLUSH
    IDB_16_DIAG_KNLTRACEOFF
    IDB_16_DIAG_KNLTRACECLEAR
    IDB_16_INFO_CONFIG
    IDB_16_INFO_IO
    IDB_16_INFO_LOCKS
    IDB_16_INFO_USERS
    IDB_16_INFO_INFO
    IDB_16_INFO_DEVICES
    IDB_16_INFO_CACHE
    IDB_16_INFO_DATA
    IDB_16_INFO_LOG
    IDB_16_INFO_UPDSTAT
    IDB_16_INFO_BADIDX
    IDB_16_INFO_VERSION
    IDB_16_DIAG_MONITOR
    IDB_16_USERS
    IDB_16_MAPCHARSETS
    IDB_16_PARAMETERS
    IDB_16_TERMCHARSETS
    IDB_16_DEVSPACES
    IDB_16_SYSTABLES
    IDB_16_CONFIGURATION
    IDB_16_DIAGNOSE
    IDB_16_BACKUP_ST_AUTO
    IDB_16_ROOT_NODE
    IDB_16_BALL_BLUE
    IDB_16_MAPCHARSET_NEW
    IDB_16_TERMCHARSET_NEW
    IDB_16_WEB_CANCEL
    IDB_16_BACKUP_REPLACE
    IDB_16_BACKUP_IGNORE
    IDB_16_DB_UNREGISTER
    IDB_16_USER_NEW
    IDB_16_WINDOWS
    IDB_16_FILES
    IDB_16_FILE
    IDB_16_FILE_VIEW
    IDB_16_PARAM_GENERAL
    IDB_16_PARAM_EXTENDED
    IDB_16_PARAM_SUPPORT
    IDB_16_PARAM_ALL
    IDB_16_DEVSPACE_SYS
    IDB_16_DEVSPACE_DATA
    IDB_16_DEVSPACE_LOG
    IDB_16_DEVSPACE_DATA_NEW
    IDB_16_DEVSPACE_LOG_NEW
    IDB_16_EXCLAMATION
    IDB_16_SHOWS
    IDB_16_SHOW
    IDB_16_SHOW_VIEW
    IDB_16_DEVSPACE_SYS_NEW
    IDB_16_DEVSPACE_SYS_NE
    IDB_16_DEVSPACE_DATA_NE
    IDB_16_DEVSPACE_LOG_NE
    IDB_16_DEVSPACE_SYS_MI
    IDB_16_DEVSPACE_DATA_MI
    IDB_16_DEVSPACE_LOG_MI
    IDB_16_DEVSPACE_SYS_MI_NE
    IDB_16_DEVSPACE_DATA_MI_NE
    IDB_16_DEVSPACE_LOG_MI_NE
    IDB_16_OK
    IDB_16_CANCEL
    IDB_16_COMMANDEXEUTE
    IDB_16_COMMAND
    IDB_16_INFO
    IDB_16_INFOOK
    IDB_16_WARNING
    IDB_16_QUESTION
    IDB_16_ERROR
    IDB_16_STOP
    IDB_16_CLOCK
    IDB_16_RENAME
    IDB_16_STEP_NEXT
    IDB_16_STEP_PREV
    IDB_16_CREATE
    IDB_16_SEARCH
    IDB_16_CLOSE
    IDB_16_SAP_LOGO_2
    IDB_16_PARAMETER_LIST
    IDB_16_EVENTS
    IDB_16_EVENT_ON
    IDB_16_EVENT_OFF
    IDB_16_SEARCH_NEXT
    IDB_16_EVENT_MONITOR
    IDB_16_EVENT_PRIO_HIG
    IDB_16_EVENT_PRIO_MED
    IDB_16_EVENT_PRIO_LOW
    IDB_16_PARAM_GENERAL_CHANGED
    IDB_16_PARAM_EXTENDED_CHANGED
    IDB_16_PARAM_SUPPORT_CHANGED
    IDB_16_UPDSTAT
    IDB_16_INDEXES
    IDB_16_SEARCH_PREV
    IDB_16_DETAIL_SHOW
    IDB_16_DETAIL_HIDE
    IDB_16_GREEN
    IDB_16_RED
    IDB_16_RECREATE
    IDB_16_SELECT_ALL
    IDB_16_SELECT_NONE
    IDB_16_TABLE
    IDB_16_TABLES
    IDB_16_COLUMN
    IDB_16_COLUMNS
    IDB_16_CLEAR
    IDB_16_MAINTENANCE
    IDB_16_REINTEGRATE_DEVSPACE
    IDB_16_VERIFY
    IDB_16_DB_STPINC
    IDB_16_AUTOLOG_CANCEL
    IDB_16_KNLTRACE_ALL_OFF
    IDB_16_CANCEL_BACK
    IDB_16_EVENTS_SET
    IDB_16_CHECK_MEDIUM
    IDB_16_SQL_STUDIO
    IDB_16_LOGMODE_DEMO
    IDB_16_LOGMODE_SINGLE
    IDB_16_LOGMODE_DUAL
    IDB_16_SERVER
    IDB_16_LOGMODE_DUALDEMO
    IDB_16_USER_DBM
    IDB_16_USER_DBA
    IDB_16_CURRENT_WRITE_POS
    IDB_16_PARAMS_EXTSUP
    IDB_16_REFRESH_EXT
    IDB_16_WIN_NEXT
    IDB_16_WIN_PREV
    IDB_16_KNLTRACE_ONLEVEL
    IDB_16_SESSIONS
    IDB_16_KILL_SESSIONS
    IDB_16_DISCONNECT
End Enum

Public Enum Bitmap32ResourceIDConstants
    IDB_32_DB_COLD = 1
    IDB_32_DB
    IDB_32_DB_WHITE
    IDB_32_DB_GREY
    IDB_32_DB_NOTEXISTS
    IDB_32_DB_OFFLINE
    IDB_32_DB_UNKOWN
    IDB_32_DB_WAIT
    IDB_32_DB_WARM
    IDB_32_DB_STPINC
    IDB_32_SERVER
End Enum

'''

Public Enum IconResourceIDConstants
    IDI_DBMGUI = 1
    IDI_DBMAPP
    IDI_DBMWIZ
    IDI_DB
    IDI_DB_DRAG
    IDI_DB_NODROP
    IDI_FOLDER_DRAG
    IDI_FOLDER_NODROP
End Enum

'''

Public Enum DBMResourceInstanceImagleListConstants
    dbmResInstImlNone = 1
    dbmResInstImlNone_GREY
    dbmResInstImlNone_WHITE
    dbmResInstImlOLTP
    dbmResInstImlOLTP_GREY
    dbmResInstImlOLTP_WHITE
    dbmResInstImlLVC
    dbmResInstImlLVC_GREY
    dbmResInstImlLVC_WHITE
    dbmResInstImlCS
    dbmResInstImlCS_GREY
    dbmResInstImlCS_WHITE
    dbmResInstImlBW
    dbmResInstImlBW_GREY
    dbmResInstImlBW_WHITE
    dbmResInstImlGREY
    dbmResInstImlRED
    dbmResInstImlYELLOW
    dbmResInstImlGREEN
    dbmResInstImlEXCLAMATION
    dbmResInstImlINFO_OK
    dbmResInstImlINFO_WARNING
    dbmResInstImlWait
End Enum

Public Enum DBMResourceBitmapInstanceSizeConstants
    dbmResBMPInstSizeLarge
    dbmResBMPInstSizeSmall
End Enum

Public Enum DBMResourceBitmapInstanceTypeConstants
    dbmResBMPInstTypeNone
    dbmResBMPInstTypeOLTP
    dbmResBMPInstTypeLVC
    dbmResBMPInstTypeCS
    dbmResBMPInstTypeBW
End Enum

Const INSTANCE_TYPE_COUNT = dbmResBMPInstTypeBW + 1

Public Enum DBMResourceBitmapInstanceStateConstants
    dbmResBMPInstStateNone
    dbmResBMPInstStateAllGrey
    dbmResBMPInstStateAllWhite
    dbmResBMPInstStateGrey
    dbmResBMPInstStateRed
    dbmResBMPInstStateYellow
    dbmResBMPInstStateGreen
    dbmResBMPInstStateExclamation
End Enum

Const INSTANCE_STATE_COUNT = dbmResBMPInstStateExclamation + 1

'''

Private f As frmResource

Private oBitmaps16 As MSComCtlLib.ImageList
Private oBitmaps32 As MSComCtlLib.ImageList
Private oIcons As MSComCtlLib.ImageList

'''

Public Property Get Bitmap16(ByVal ID As Bitmap16ResourceIDConstants) As StdPicture
    Set Bitmap16 = oBitmaps16.ListImages(ID).ExtractIcon
End Property

Public Property Get Bitmap16ID(ByVal ID As Bitmap16ResourceIDConstants) As Integer
    Bitmap16ID = ID
End Property

Public Property Get Bitmap16Overlay(ByVal ID1 As Bitmap16ResourceIDConstants, _
                                    ByVal ID2 As Bitmap16ResourceIDConstants) As StdPicture
    oBitmaps16.BackColor = BACKCOLOR_MASK
    Set Bitmap16Overlay = oBitmaps16.Overlay(ID1, ID2)
    oBitmaps16.BackColor = BACKCOLOR_DEFAULT
End Property

Public Property Get Bitmap16Overlay3(ByVal ID1 As Bitmap16ResourceIDConstants, _
                                     ByVal ID2 As Bitmap16ResourceIDConstants, _
                                     ByVal ID3 As Bitmap16ResourceIDConstants) As StdPicture
    oBitmaps16.BackColor = BACKCOLOR_MASK
    oBitmaps16.ListImages.Add , "OVERLAY", oBitmaps16.Overlay(ID1, ID2)
    Set Bitmap16Overlay3 = oBitmaps16.Overlay("OVERLAY", ID3)
    oBitmaps16.ListImages.Remove "OVERLAY"
    oBitmaps16.BackColor = BACKCOLOR_DEFAULT
End Property

'''

Public Property Get Bitmap32(ByVal ID As Bitmap32ResourceIDConstants) As StdPicture
    Set Bitmap32 = oBitmaps32.ListImages(ID).ExtractIcon
End Property

Public Property Get Bitmap32ID(ByVal ID As Bitmap32ResourceIDConstants) As Integer
    Bitmap32ID = ID
End Property

Public Property Get Bitmap32Overlay(ByVal ID1 As Bitmap32ResourceIDConstants, _
                                    ByVal ID2 As Bitmap32ResourceIDConstants) As StdPicture
    oBitmaps32.BackColor = BACKCOLOR_MASK
    Set Bitmap32Overlay = oBitmaps32.Overlay(ID1, ID2)
    oBitmaps32.BackColor = BACKCOLOR_DEFAULT
End Property

'''

Public Property Get Icon(ByVal ID As IconResourceIDConstants) As StdPicture
    Set Icon = oIcons.ListImages(ID).ExtractIcon
End Property

Public Property Get IconID(ByVal ID As IconResourceIDConstants) As Integer
    IconID = ID
End Property

'''

Public Property Get Bitmaps16() As Object
    If Not f Is Nothing Then
        Set Bitmaps16 = f.imlBitmaps16
    End If
End Property

Public Property Get Bitmaps32() As Object
    If Not f Is Nothing Then
        Set Bitmaps32 = f.imlBitmaps32
    End If
End Property

Public Property Get Icons() As Object
    If Not f Is Nothing Then
        Set Icons = f.imlIcons
    End If
End Property

'''

Public Property Get ImageSAP() As StdPicture
    Set ImageSAP = f.imgSAP.Picture
End Property

Public Property Get ImageLogo() As StdPicture
    Set ImageLogo = f.imgLogo.Picture
End Property

'''

Public Property Get ColorSAPBlue() As Long
    ColorSAPBlue = SAP_BLUE
End Property

Public Property Get ColorSAPGrey() As Long
    ColorSAPGrey = SAP_GREY
End Property

'''

Public Property Get InstanceID(ByVal InstType As DBMResourceBitmapInstanceTypeConstants, _
                               Optional ByVal InstState As DBMResourceBitmapInstanceStateConstants = dbmResBMPInstStateNone, _
                               Optional ByVal Wait As Boolean = False) As Long
    
    InstanceID = InstanceIDFirst(Wait) + (InstType * INSTANCE_STATE_COUNT) + InstState
End Property

Public Property Get InstanceIDSetWait(ByVal Index As Long, _
                                      ByVal Wait As Boolean) As Long
    Select Case Wait
        Case True:
            If Index < InstanceIDFirst(True) Then
                InstanceIDSetWait = Index + InstanceIDWaitOffset
            Else
                InstanceIDSetWait = Index
            End If
        Case False:
            If Index >= InstanceIDFirst(True) Then
                InstanceIDSetWait = Index - InstanceIDWaitOffset
            Else
                InstanceIDSetWait = Index
            End If
    End Select
End Property

Public Property Get InstanceIDFirst(Optional ByVal Wait As Boolean = False) As Long
    If Not Wait Then
        InstanceIDFirst = dbmResInstImlWait + 1
    Else
        InstanceIDFirst = dbmResInstImlWait + (INSTANCE_STATE_COUNT * INSTANCE_TYPE_COUNT) + 1
    End If
End Property

Public Property Get InstanceIDWaitOffset() As Long
    InstanceIDWaitOffset = InstanceIDFirst(True) - InstanceIDFirst(False)
End Property

Public Property Get Instances(ByVal Size As DBMResourceBitmapInstanceSizeConstants) As Object
    If Not f Is Nothing Then
        Select Case Size
            Case dbmResBMPInstSizeLarge: Set Instances = f.imlInstances32
            Case dbmResBMPInstSizeSmall: Set Instances = f.imlInstances16
        End Select
    Else
        Set Instances = Nothing
    End If
End Property

Public Property Get InstancePicture(ByVal Size As DBMResourceBitmapInstanceSizeConstants, _
                                    ByVal InstType As DBMResourceBitmapInstanceTypeConstants, _
                                    Optional ByVal InstState As DBMResourceBitmapInstanceStateConstants = dbmResBMPInstStateNone, _
                                    Optional ByVal Wait As Boolean) As StdPicture
        
    If Not f Is Nothing Then
        Select Case Size
            Case dbmResBMPInstSizeLarge:
                Set InstancePicture = f.imlInstances32.ListImages(InstanceID(InstType, InstState, Wait)).Picture
            Case dbmResBMPInstSizeSmall:
                Set InstancePicture = f.imlInstances16.ListImages(InstanceID(InstType, InstState, Wait)).Picture
        End Select
    Else
        Set InstancePicture = Nothing
    End If
End Property

Public Property Get InstanceIcon(ByVal Size As DBMResourceBitmapInstanceSizeConstants, _
                                 ByVal InstType As DBMResourceBitmapInstanceTypeConstants, _
                                 Optional ByVal InstState As DBMResourceBitmapInstanceStateConstants = dbmResBMPInstStateNone, _
                                 Optional ByVal Wait As Boolean) As StdPicture
    
    If Not f Is Nothing Then
        Select Case Size
            Case dbmResBMPInstSizeLarge:
                Set InstanceIcon = f.imlInstances32.ListImages(InstanceID(InstType, InstState, Wait)).ExtractIcon
            Case dbmResBMPInstSizeSmall:
                Set InstanceIcon = f.imlInstances16.ListImages(InstanceID(InstType, InstState, Wait)).ExtractIcon
        End Select
    Else
        Set InstanceIcon = Nothing
    End If
End Property

Public Property Get InstanceImageListID(ByVal Index As DBMResourceInstanceImagleListConstants) As Long
    InstanceImageListID = Index
End Property

Public Property Get InstanceImageListPicture(ByVal Size As DBMResourceBitmapInstanceSizeConstants, _
                                             ByVal Index As DBMResourceInstanceImagleListConstants) As StdPicture
    If Not f Is Nothing Then
        Select Case Size
            Case dbmResBMPInstSizeLarge:
                Set InstanceImageListPicture = f.imlInstances32.ListImages(Index).Picture
            Case dbmResBMPInstSizeSmall:
                Set InstanceImageListPicture = f.imlInstances16.ListImages(Index).Picture
        End Select
    Else
        Set InstanceImageListPicture = Nothing
    End If
End Property

Public Property Get InstanceImageListIcon(ByVal Size As DBMResourceBitmapInstanceSizeConstants, _
                                          ByVal Index As DBMResourceInstanceImagleListConstants) As StdPicture
    If Not f Is Nothing Then
        Select Case Size
            Case dbmResBMPInstSizeLarge:
                Set InstanceImageListIcon = f.imlInstances32.ListImages(Index).ExtractIcon
            Case dbmResBMPInstSizeSmall:
                Set InstanceImageListIcon = f.imlInstances16.ListImages(Index).ExtractIcon
        End Select
    Else
        Set InstanceImageListIcon = Nothing
    End If
End Property

'''

Private Sub Class_Initialize()
    Set f = New frmResource
    
    Set oBitmaps16 = f.imlBitmaps16
    Set oBitmaps32 = f.imlBitmaps32
    Set oIcons = f.imlIcons
    
    MakeInstanceImages f.imlInstances16
    MakeInstanceImages f.imlInstances32
End Sub

Private Sub Class_Terminate()
    If Not f Is Nothing Then
        Unload f
        Set f = Nothing
    End If
End Sub

Private Sub MakeInstanceImages(ByVal oInstances As MSComCtlLib.ImageList)
    Dim lImage As Long
    Dim lCount As Long
    
    With oInstances
        .BackColor = BACKCOLOR_MASK
        
        .ListImages.Add , , .ListImages(dbmResInstImlNone).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlNone_GREY).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlNone_WHITE).Picture
        .ListImages.Add , , .Overlay(dbmResInstImlNone, dbmResInstImlGREY)
        .ListImages.Add , , .Overlay(dbmResInstImlNone, dbmResInstImlRED)
        .ListImages.Add , , .Overlay(dbmResInstImlNone, dbmResInstImlYELLOW)
        .ListImages.Add , , .Overlay(dbmResInstImlNone, dbmResInstImlGREEN)
        .ListImages.Add , , .Overlay(dbmResInstImlNone, dbmResInstImlEXCLAMATION)
        
        .ListImages.Add , , .ListImages(dbmResInstImlOLTP).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlOLTP_GREY).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlOLTP_WHITE).Picture
        .ListImages.Add , , .Overlay(dbmResInstImlOLTP, dbmResInstImlGREY)
        .ListImages.Add , , .Overlay(dbmResInstImlOLTP, dbmResInstImlRED)
        .ListImages.Add , , .Overlay(dbmResInstImlOLTP, dbmResInstImlYELLOW)
        .ListImages.Add , , .Overlay(dbmResInstImlOLTP, dbmResInstImlGREEN)
        .ListImages.Add , , .Overlay(dbmResInstImlOLTP, dbmResInstImlEXCLAMATION)
        
        .ListImages.Add , , .ListImages(dbmResInstImlLVC).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlLVC_GREY).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlLVC_WHITE).Picture
        .ListImages.Add , , .Overlay(dbmResInstImlLVC, dbmResInstImlGREY)
        .ListImages.Add , , .Overlay(dbmResInstImlLVC, dbmResInstImlRED)
        .ListImages.Add , , .Overlay(dbmResInstImlLVC, dbmResInstImlYELLOW)
        .ListImages.Add , , .Overlay(dbmResInstImlLVC, dbmResInstImlGREEN)
        .ListImages.Add , , .Overlay(dbmResInstImlLVC, dbmResInstImlEXCLAMATION)
        
        .ListImages.Add , , .ListImages(dbmResInstImlCS).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlCS_GREY).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlCS_WHITE).Picture
        .ListImages.Add , , .Overlay(dbmResInstImlCS, dbmResInstImlGREY)
        .ListImages.Add , , .Overlay(dbmResInstImlCS, dbmResInstImlRED)
        .ListImages.Add , , .Overlay(dbmResInstImlCS, dbmResInstImlYELLOW)
        .ListImages.Add , , .Overlay(dbmResInstImlCS, dbmResInstImlGREEN)
        .ListImages.Add , , .Overlay(dbmResInstImlCS, dbmResInstImlEXCLAMATION)
        
        .ListImages.Add , , .ListImages(dbmResInstImlBW).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlBW_GREY).Picture
        .ListImages.Add , , .ListImages(dbmResInstImlBW_WHITE).Picture
        .ListImages.Add , , .Overlay(dbmResInstImlBW, dbmResInstImlGREY)
        .ListImages.Add , , .Overlay(dbmResInstImlBW, dbmResInstImlRED)
        .ListImages.Add , , .Overlay(dbmResInstImlBW, dbmResInstImlYELLOW)
        .ListImages.Add , , .Overlay(dbmResInstImlBW, dbmResInstImlGREEN)
        .ListImages.Add , , .Overlay(dbmResInstImlBW, dbmResInstImlEXCLAMATION)
        
        lCount = .ListImages.Count
        
        For lImage = dbmResInstImlWait + 1 To lCount
            .ListImages.Add , , .Overlay(lImage, dbmResInstImlWait)
        Next
        
        .BackColor = BACKCOLOR_DEFAULT
    End With
End Sub

