VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Application"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum DBMWizInstallModeConstants
    dbmWizInstallModeInstall
    dbmWizInstallModeRestore
End Enum

Public Enum DBMWizParamInitModeConstants
    dbmWizParamInitModeInit
    dbmWizParamInitModeUse
    dbmWizParamInitModeCopy
    dbmWizParamInitModeRestore
End Enum
    
'''

Private oInstallData As InstallData

'''

Private oWizardEvents As IWizardEvents

'''

Private bHideOnTerminate As Boolean

'''

Public Property Get InstallData() As InstallData
    If oInstallData Is Nothing Then
        Set oInstallData = New InstallData
    End If
    Set InstallData = oInstallData
End Property

'''

Public Property Get WizardEvents() As IWizardEvents
    Set WizardEvents = oWizardEvents
End Property

Public Property Set WizardEvents(ByVal NewVal As IWizardEvents)
    Set oWizardEvents = NewVal
End Property


Public Property Get HideOnTerminate() As Boolean
    HideOnTerminate = bHideOnTerminate
End Property
Public Property Let HideOnTerminate(ByVal NewVal As Boolean)
    bHideOnTerminate = NewVal
End Property

'''

Public Sub ShowForm()
    If FRM Is Nothing Then
        Set FRM = New frmWizard
    End If
    
    FRM.Show
End Sub

Public Sub HideForm()
    If Not FRM Is Nothing Then
        Unload FRM
        Set FRM = Nothing
    End If
End Sub

'''

Private Sub Class_Initialize()
    Set oInstallData = Nothing
    
    If App.StartMode = vbSModeStandalone Then
        ShowForm
    End If
    
    Set GUI = Me
    
    bHideOnTerminate = False
End Sub

Private Sub Class_Terminate()
    If bHideOnTerminate Then
        HideForm
    End If
End Sub

'''

