VERSION 5.00
Begin VB.Form frmShutdown 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Shutdown Database Instance"
   ClientHeight    =   1560
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4635
   Icon            =   "Shutdown.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1560
   ScaleWidth      =   4635
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   3
      Top             =   1020
      Width           =   1095
   End
   Begin VB.CommandButton cmdQuick 
      Caption         =   "&Quick"
      Height          =   375
      Left            =   2100
      TabIndex        =   2
      Top             =   1020
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   840
      TabIndex        =   1
      Top             =   1020
      Width           =   1095
   End
   Begin VB.Label lblInfo 
      Caption         =   "To break off all running transactions for shutdown choose 'Quick'. To finish all running transactions before shutdown choose 'OK'"
      Height          =   615
      Left            =   900
      TabIndex        =   0
      Top             =   180
      Width           =   3495
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   180
      Picture         =   "Shutdown.frx":000C
      Top             =   180
      Width           =   480
   End
End
Attribute VB_Name = "frmShutdown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit


Private Enum CommandConstants
    cmdOK
    cmdQuick
    cmdCancel
End Enum

'''

Private lCommand As CommandConstants
Private lMousePointer As Long

'''

Public Function Shutdown(sDatabase As String, bQuick As Boolean) As Boolean
    Dim bCancel As Boolean
    
    bCancel = True
    
    lMousePointer = Screen.MousePointer
    Screen.MousePointer = vbDefault
    
    Me.Show vbModal
    
    Select Case lCommand
        Case cmdOK:
            bQuick = False
            bCancel = False
        Case cmdQuick:
            bQuick = True
            bCancel = False
        Case cmdCancel:
            bQuick = False
    End Select
    
    Unload Me
    
    Screen.MousePointer = lMousePointer
    
    Shutdown = Not bCancel
End Function

Private Sub cmdCancel_Click()
    lCommand = cmdCancel
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    lCommand = cmdOK
    Me.Hide
End Sub

Private Sub cmdQuick_Click()
    lCommand = cmdQuick
    Me.Hide
End Sub
