Attribute VB_Name = "DisableListImage"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function DrawState Lib "user32.dll" Alias "DrawStateA" ( _
    ByVal hDC As Long, _
    ByVal hBrush As Long, _
    ByVal lpDrawStateProc As Long, _
    ByVal lParam As Long, _
    ByVal wParam As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal fuFlags As Long) As Long

Const DST_ICON = &H3
Const DST_BITMAP = &H4
Const DSS_DISABLED = &H20

Public Sub DisableListImage(ImageList As Object, _
                            Index As Variant, _
                            ByVal hDestDC As Long, _
                            ByVal x As Long, _
                            ByVal y As Long)
    If ImageList Is Nothing Then Exit Sub
    If ImageList.ListImages.Count = 0 Then Exit Sub
    
    DrawState hDestDC, 0, 0, ImageList.ListImages(Index).ExtractIcon.Handle, 0, x, y, ImageList.ImageWidth, ImageList.ImageHeight, DST_ICON + DSS_DISABLED
End Sub
