Attribute VB_Name = "TimerMenubar"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oCML As CommandList
Private oItem As CommandItem

Private lTimerID As Long
Private bInExecute As Boolean

Public Sub AsyncClick(oCommandList As CommandList, oCommandItem As CommandItem)
    Set oCML = oCommandList
    Set oItem = oCommandItem
    
    StopTimer
    
    lTimerID = SetTimer(0, 0, 10, AddressOf TimerProc)
End Sub

'''

Private Sub StopTimer()
    If lTimerID <> 0 Then
        KillTimer 0, lTimerID
        lTimerID = 0
    End If
End Sub

Private Sub TimerProc(ByVal lhWnd As Long, _
                      ByVal lMsg As Long, _
                      ByVal lTimerID As Long, _
                      ByVal lTime As Long)
    StopTimer
    
    If Not oCML Is Nothing Then
        If Not oItem Is Nothing Then
             oCML.EventItemClick oItem
        End If
    End If
End Sub


