VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ToolbarItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oToolBar As ToolBar

Private oCommandItem As CommandItem
Private oButton As MSComCtlLib.Button

Private lID As Long
'
' Public Properties
'
Public Property Get CommandItem() As CommandItem
    Set CommandItem = oCommandItem
End Property
Public Property Set CommandItem(NewVal As CommandItem)
    Set oCommandItem = NewVal
End Property
'
' Friends Properties
'
Friend Property Get ID() As Long
    ID = lID
End Property
Friend Property Let ID(ByVal NewVal As Long)
    lID = NewVal
End Property

Friend Property Get ToolBar() As ToolBar
    Set ToolBar = oToolBar
End Property
Friend Property Set ToolBar(NewVal As ToolBar)
    Set oToolBar = NewVal
End Property

Friend Property Get Button() As MSComCtlLib.Button
    Set Button = oButton
End Property
Friend Property Set Button(NewVal As MSComCtlLib.Button)
    Set oButton = NewVal
End Property
'
' Friend Sub/Function
'
Friend Sub Enabled()
    oButton.Enabled = oCommandItem.Enabled
End Sub

Friend Sub Visible()
    oButton.Visible = oCommandItem.Visible
End Sub

Friend Sub Value()
    oButton.Value = oCommandItem.Value
End Sub

Public Sub CleanUp()
    Set oToolBar = Nothing
    Set oCommandItem = Nothing
    Set oButton = Nothing
End Sub
'
' Private0
'
' Initialize/Terminate
'
Private Sub Class_Initialize()
    Set oToolBar = Nothing
    Set oCommandItem = Nothing
    Set oButton = Nothing
    lID = 0
End Sub


