VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Begin VB.UserControl DBMDocEventMonitor 
   ClientHeight    =   2100
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3555
   KeyPreview      =   -1  'True
   ScaleHeight     =   2100
   ScaleWidth      =   3555
   ToolboxBitmap   =   "DBMDocEventMonitor.ctx":0000
   Begin MSComctlLib.ListView lvwEvents 
      Height          =   1515
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2955
      _ExtentX        =   5212
      _ExtentY        =   2672
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   8
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Priority"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Occurence"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Count"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Text            =   "Value1"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(6) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   5
         Text            =   "Value2"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(7) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   6
         Text            =   "Text"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(8) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   7
         Text            =   "Description"
         Object.Width           =   2540
      EndProperty
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   1650
      Width           =   3555
      _ExtentX        =   6271
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   3120
      Top             =   780
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   3120
      Top             =   420
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   3120
      Top             =   60
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin VB.Menu mnuEventMonitor 
      Caption         =   "EventMonitor"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "DBMDocEventMonitor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_COLD + DB_STATE_WARM

Private Enum DBMDocEventMonitorCommands
    cmdEventMonitor
    cmdEventMonitorClear
    cmdSeperator
End Enum

Const CMD_FIRST = cmdEventMonitor
Const CMD_LAST = cmdSeperator

Private Enum EventMonitorPopupConstants
    popEvents = 1
    popEvent
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean


'''

Private Enum EventMonitorColumnConstants
    ecName
    ecPriority
    ecOccurrence
    ecCount
    ecValue1
    ecValue2
    ecText
    ecDescription
End Enum

'''

Private bFitColumnSize As Boolean

'''

Public Event WrongDBState()

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_EVENT_MONITOR
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = "Check - Events"
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Get Database() As DBMLib.Database
    Set Database = oDB
End Property
Public Property Set Database(NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    EventsRefresh
End Sub

Public Sub FitColumnSize()
    ListViewUtil.FitColumnSize lvwEvents, True
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
    Cancel = False
End Sub

Public Sub Reset()
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    bEnabled = True
    
    bToolBar = True
    bPopup = True

    bFitColumnSize = True

    EventMonitorInit
    CommandInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    lvwEvents.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub
'
' lvwEvents
'
Private Sub lvwEvents_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As MSComctlLib.ListItem
    
    If Button = vbRightButton Then
        Set oItem = lvwEvents.HitTest(x, y)
        If oItem Is Nothing Then
            POP.Show popEvent
        Else
            POP.Show popEvents
        End If
    End If
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_StateChanged()
    If Not IsStateOK(oDB.State.Value, VALID_DB_STATE) Then
        RaiseEvent WrongDBState
    End If
End Sub

Private Sub oDB_DatabaseEvent(ByVal EventType As DBMLib.DBMDatabaseEventTypeConstants, ByVal Name As String, ByVal Priority As String, ByVal Occurrence As Date, ByVal Count As Long, ByVal Value1 As String, ByVal Value2 As String, ByVal Text As String, ByVal Description As String)
    Dim oItem As MSComctlLib.ListItem
    Dim lCount As Long
    
    Set oItem = lvwEvents.ListItems.Add(1, , Name)
    With oItem
        Select Case Priority
            Case "LOW":     .SmallIcon = oRes.Bitmap16ID(IDB_16_EVENT_PRIO_LOW)
            Case "MEDIUM":  .SmallIcon = oRes.Bitmap16ID(IDB_16_EVENT_PRIO_MED)
            Case "HIGH":    .SmallIcon = oRes.Bitmap16ID(IDB_16_EVENT_PRIO_HIG)
            Case Else:      .SmallIcon = oRes.Bitmap16ID(IDB_16_EVENT_PRIO_LOW)
        End Select

        .SubItems(ecPriority) = Priority
        .SubItems(ecOccurrence) = Occurrence
        .SubItems(ecCount) = Count
        .SubItems(ecValue1) = Value1
        .SubItems(ecValue2) = Value2
        .SubItems(ecText) = Text
        .SubItems(ecDescription) = Description
    End With
    
    lCount = lvwEvents.ListItems.Count
    
    If lCount > 1024 Then
        lvwEvents.ListItems.Remove lCount
    End If
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdEventMonitorClear:  EventMonitorClear
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdEventMonitor, "&Events", 0
        .Add cmdTypeDefault, cmdEventMonitorClear, "&Clear", oRes.Bitmap16ID(IDB_16_CLEAR)
        
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdEventMonitorClear)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdEventMonitor)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdEventMonitorClear)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
    
    PopupEventsInit
    PopupEventInit
End Sub

Private Sub PopupEventsInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdEventMonitorClear)
    End With
End Sub

Private Sub PopupEventInit()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdEventMonitorClear)
    End With
End Sub

'''

Private Sub EventMonitorInit()
    lvwEvents.SmallIcons = oRes.Bitmaps16
End Sub

Private Sub EventsRefresh()
    lvwEvents.ListItems.Clear
    TIBEnabled oTIB, True
End Sub

'''

Private Sub EventMonitorClear()
    lvwEvents.ListItems.Clear
End Sub
