VERSION 5.00
Object = "{35FFD273-D85B-11D2-AA86-00A0C9447ED5}#1.1#0"; "DBMCmd.ocx"
Object = "{BAA397ED-F377-11D4-B32D-0050DADEFE1A}#1.1#0"; "DBMDrt.ocx"
Begin VB.UserControl DBMDocVerify 
   ClientHeight    =   2490
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3645
   ScaleHeight     =   2490
   ScaleWidth      =   3645
   ToolboxBitmap   =   "DBMDocVerify.ctx":0000
   Begin VB.PictureBox picInfo 
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      Height          =   1035
      Left            =   60
      ScaleHeight     =   1035
      ScaleWidth      =   2715
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   60
      Width           =   2715
      Begin DBMDrt.DrawText drtInfo 
         Height          =   195
         Left            =   60
         Top             =   120
         Width           =   1815
         _ExtentX        =   3201
         _ExtentY        =   344
         Caption         =   "Info"
         BackColor       =   -2147483643
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
      End
   End
   Begin DBMCmd.ToolBar TBR 
      Align           =   2  'Align Bottom
      Height          =   450
      Left            =   0
      TabIndex        =   0
      Top             =   2040
      Width           =   3645
      _ExtentX        =   6429
      _ExtentY        =   794
      BorderStyle     =   6
      Enabled         =   -1  'True
      ShowCaptions    =   0   'False
      StyleFlat       =   -1  'True
      StyleList       =   0   'False
   End
   Begin DBMCmd.Popup POP 
      Left            =   2820
      Top             =   780
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.CommandList CML 
      Left            =   2820
      Top             =   60
      _ExtentX        =   529
      _ExtentY        =   529
   End
   Begin DBMCmd.MenuBar MBR 
      Left            =   2820
      Top             =   420
      _ExtentX        =   529
      _ExtentY        =   529
   End
End
Attribute VB_Name = "DBMDocVerify"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VALID_DB_STATE = DB_STATE_WARM + DB_STATE_COLD

Private Enum DBMDocVerifyCommands
    cmdVerify
    cmdVerifyExecute
    cmdVerifyClearSep
    cmdVerifyClear
    cmdSeperator
End Enum

Const CMD_FIRST = cmdVerify
Const CMD_LAST = cmdSeperator

Private Enum VerifyPopupConstants
    popVerify = 1
End Enum

Private bPopup As Boolean

Private oMenuBar As Object
Private iPosition As Integer

Private bEnabled As Boolean
Private bToolBar As Boolean

'''
Private oTIB As Object
Private WithEvents oDB As DBMLib.Database
Attribute oDB.VB_VarHelpID = -1
Private bRunning As Boolean


'''

Private lSenderID As Long

'''

Public Event WrongDBState()

'''

Public Property Get PictureID() As Integer
    PictureID = IDB_16_VERIFY
End Property

Public Property Get Picture() As StdPicture
    Set Picture = oRes.Bitmap16(PictureID)
End Property

Public Property Get Caption() As String
    Dim s As String
    s = "Check - Database Structure"
    If Not oDB Is Nothing Then s = s + " - " + oDB.Name
    Caption = s
End Property

Public Property Set Database(ByVal NewVal As DBMLib.Database)
    Set oDB = NewVal
    TIBCaption oTIB, Caption
End Property

Public Property Get ToolBar() As Boolean
    ToolBar = bToolBar
End Property
Public Property Let ToolBar(ByVal NewVal As Boolean)
    bToolBar = NewVal
    TBR.Visible = NewVal
    UserControl_Resize
    PropertyChanged "ToolBar"
End Property

Public Property Get Popup() As Boolean
    Popup = bPopup
End Property
Public Property Let Popup(ByVal NewVal As Boolean)
    bPopup = NewVal
    PropertyChanged "Popup"
End Property

Public Property Set TitleBar(ByVal NewVal As Object)
    Set oTIB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    bEnabled = NewVal
    If Ambient.UserMode Then
        UserControl.Enabled = bEnabled
    End If
    PropertyChanged "Enabled"
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

Public Property Get Running() As Boolean
    Running = bRunning
End Property

Public Property Get At() As Date
    At = Empty
End Property
'
' Methods
'
Public Sub Init()
End Sub

Public Sub ShowMenu(ByVal MenuBar As Object, _
                    ByVal After As Integer)
    If oMenuBar Is Nothing Then
        Set oMenuBar = MenuBar
        iPosition = oMenuBar.AddMenuBarItem(MBR.MenuBarItems(1), After)
    End If
End Sub

Public Sub HideMenu()
    If Not oMenuBar Is Nothing Then
        oMenuBar.RemoveMenuBarItem iPosition
        Set oMenuBar = Nothing
        iPosition = 0
    End If
End Sub

Public Sub Refresh()
    VerifyRefresh
End Sub

Public Sub QueryClose(ByVal CloseMode As Long, _
                      Cancel As Boolean)
                     
    Cancel = False
End Sub

Public Sub Reset()
    VerifyReset
    
    Set oDB = Nothing
End Sub

Public Sub CleanUp()
    MBR.CleanUp
    POP.CleanUp
    TBR.CleanUp
    CML.CleanUp
End Sub
'
' UserControl
'
Private Sub UserControl_Initialize()
    lSenderID = GetSenderID()
    
    bEnabled = True
    
    bToolBar = True
    bPopup = True
    
    CommandInit
    VerifyInit
End Sub

Private Sub UserControl_Show()
    On Error Resume Next
    
    If Not Ambient.UserMode Then
        UserControl.Enabled = False
    Else
        UserControl.Enabled = bEnabled
    End If
End Sub

Private Sub UserControl_Resize()
    Dim iTop As Integer
    Dim iHeight As Integer
    Dim iWidth  As Integer
    
    iTop = 0
    iHeight = ScaleHeight
    If bToolBar Then iHeight = iHeight - TBR.Height
    If iHeight < 0 Then iHeight = 0
    
    picInfo.Move 0, iTop, ScaleWidth, iHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ReadDefaultProps PropBag, Me
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    WriteDefaultProps PropBag, Me
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case Shift
        Case 0:
            Select Case KeyCode
                Case vbKeyF5:
            End Select
    
        Case vbCtrlMask:
            Select Case KeyCode
                Case vbKeyF4:   'RaiseEvent CloseClick
            End Select
    End Select
End Sub
'
' oDB
'
Private Sub oDB_PropertyChanged(ByVal PropertyName As String)
    Select Case UCase(PropertyName)
        Case "NAME": TIBCaption oTIB, Caption
    End Select
End Sub

Private Sub oDB_StateChanged()
    If Not IsStateOK(oDB.State.Value, VALID_DB_STATE) Then
        RaiseEvent WrongDBState
    End If
End Sub

Private Sub oDB_DatabaseAction(ByVal SenderID As Long, ByVal Error As Boolean, ByVal Action As DBMLib.DBMDatabaseActionConstants)
    If SenderID <> lSenderID Then Exit Sub
    Select Case Action
        Case dbmDatabaseActionVerfiy: VerifyExecuted Error
    End Select
End Sub
'
' picInfo
'
Private Sub picInfo_Resize()
    Dim iWidth As Integer
    
    iWidth = picInfo.ScaleWidth - 240
    If iWidth < 0 Then iWidth = 0
    
    drtInfo.Move 120, 240, iWidth
End Sub
'
' CML
'
Private Sub CML_ItemClick(ByVal Item As DBMCmd.CommandItem)
    Select Case Item.Key
        Case cmdVerifyExecute:     VerifyExecute
        Case cmdVerifyClear:       VerifyClear
    End Select
End Sub

'''

Private Sub CommandInit()
    CommandListInit
    ToolbarInit
    MenuBarInit
    PopupInit
End Sub

Private Sub CommandListInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set CML.ImageList = oRes.Bitmaps16
    
    With CML.CommandItems
        .Add cmdTypeSubCommand, cmdVerify, "&DatabaseStructure", 0
        
        .Add cmdTypeDefault, cmdVerifyExecute, "&Execute", oRes.Bitmap16ID(IDB_16_OK)
        
        .Add cmdTypeSeperator, cmdVerifyClearSep
        .Add cmdTypeDefault, cmdVerifyClear, "&Clear", oRes.Bitmap16ID(IDB_16_CLEAR)
        
        .Add cmdTypeSeperator, cmdSeperator
    End With
End Sub

Private Sub ToolbarInit()
    Dim oItem As DBMCmd.ToolbarItem
    
    Set TBR.CommandList = CML
        
    With TBR.ToolbarItems
        Set oItem = .Add(cmdVerifyExecute)
        Set oItem = .Add(cmdVerifyClearSep)
        Set oItem = .Add(cmdVerifyClear)
    End With
End Sub

Private Sub MenuBarInit()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    Dim i As Integer
    
    Set MBR.CommandList = CML
        
    With MBR.MenuBarItems
        Set oSub = .Add(cmdVerify)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdVerifyExecute)
        Set oItem = .Add(cmdVerifyClearSep)
        Set oItem = .Add(cmdVerifyClear)
    End With
End Sub

Private Sub PopupInit()
    Set POP.CommandList = CML
End Sub

'''

Private Sub CommandsSet(ByVal bExecute As Boolean)
    bRunning = bExecute
    
    With CML.CommandItems
        .Item(cmdVerifyExecute).Enabled = Not bExecute
        .Item(cmdVerifyClear).Enabled = Not bExecute
    End With

    TIBEnabled oTIB, Not bExecute
End Sub

'''

Private Sub VerifyRefresh()
    VerifyReset
    
    If oDB Is Nothing Then Exit Sub
    
    SetInfo
    
    CommandsSet False
End Sub

'''

Private Sub VerifyInit()

End Sub

Private Sub VerifyReset()

End Sub

Private Sub VerifyExecute()
    If oDB.Verify(True, lSenderID) Then
        SetInfoExecute
        CommandsSet True
    End If
End Sub

Private Sub VerifyExecuted(ByVal bError As Boolean)
    SetInfoResult bError
    CommandsSet False
End Sub

Private Sub VerifyClear()
    SetInfo
End Sub

'''

Private Sub SetInfo()
    Dim sInfo As String

    sInfo = "Choose 'Execute' to verify the database."
    
    drtInfo.Caption = sInfo
    
    picInfo_Resize
End Sub

Private Sub SetInfoExecute()
    Dim sInfo As String
    
    sInfo = "Please wait while database is verified."

    drtInfo.Caption = sInfo
    
    picInfo_Resize
End Sub

Private Sub SetInfoResult(ByVal bError As Boolean)
    Dim sInfo As String
    
    If Not bError Then
        sInfo = "Verify of database successfully finished."
    Else
        sInfo = "An error occurred while verifying database."
    End If
    
    drtInfo.Caption = sInfo
    
    picInfo_Resize
End Sub


