VERSION 5.00
Begin VB.UserControl ctlFrameControl 
   CanGetFocus     =   0   'False
   ClientHeight    =   1185
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3195
   ScaleHeight     =   59.25
   ScaleMode       =   2  'Point
   ScaleWidth      =   159.75
End
Attribute VB_Name = "ctlFrameControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum FrameControlTypeConstants
    fctCaption = 1
    fctMenu
    fctScroll
    fctButton
    fctPopup
End Enum

Public Enum FrameControlStateCaptionConstants
    fcsCaptionClose = &H0    'Close button
    fcsCaptionMin = &H1      'Minimize button
    fcsCaptionMax = &H2      'Maximize button
    fcsCaptionRestore = &H3  'Restore button
    fcsCaptionHelp = &H4     'Help button
End Enum

Const DFCS_MENUARROW = &H0       'Submenu arrow
Const DFCS_MENUCHECK = &H1       'Check mark
Const DFCS_MENUBULLET = &H2      'Bullet
Const DFCS_MENUARROWRIGHT = &H4
Const DFCS_SCROLLUP = &H0        'Up arrow of scroll bar
Const DFCS_SCROLLDOWN = &H1      'Down arrow of scroll bar
Const DFCS_SCROLLLEFT = &H2      'Left arrow of scroll bar
                                       
Const DFCS_SCROLLRIGHT = &H3     'Right arrow of scroll bar
                                       
Const DFCS_SCROLLCOMBOBOX = &H5  'Combo box scroll bar
Const DFCS_SCROLLSIZEGRIP = &H8         'Size grip
Const DFCS_SCROLLSIZEGRIPRIGHT = &H10   'Size grip in bottom-right corner of window
Const DFCS_BUTTONCHECK = &H0     'Check box
Const DFCS_BUTTONRADIO = &H4     'Radio button
Const DFCS_BUTTON3STATE = &H8    'Three-state button
Const DFCS_BUTTONPUSH = &H10     'Push button
Const DFCS_INACTIVE = &H100      'Button is inactive (grayed)
Const DFCS_PUSHED = &H200        'Button is pushed
Const DFCS_CHECKED = &H400       'Button is checked
Const DFCS_ADJUSTRECT = &H2000   'Bounding rectangle is
                                 'adjusted to exclude the
                                 'surrounding edge of the
                                 'push button
Const DFCS_FLAT = &H4000         'Button has a flat border
Const DFCS_MONO = &H8000         'Button has a monochrome border
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'  flags for DrawFrameControl
Const DFC_CAPTION = 1            'Title bar
Const DFC_MENU = 2               'Menu
Const DFC_SCROLL = 3             'Scroll bar
Const DFC_BUTTON = 4             'Standard button
Const DFC_POPUPMENU = 5          'Popup menu item

Const DFCS_CAPTIONCLOSE = &H0    'Close button
Const DFCS_CAPTIONMIN = &H1      'Minimize button
Const DFCS_CAPTIONMAX = &H2      'Maximize button
Const DFCS_CAPTIONRESTORE = &H3  'Restore button
Const DFCS_CAPTIONHELP = &H4     'Help button

Const DFCS_MENUARROW = &H0       'Submenu arrow
Const DFCS_MENUCHECK = &H1       'Check mark
Const DFCS_MENUBULLET = &H2      'Bullet
Const DFCS_MENUARROWRIGHT = &H4
Const DFCS_SCROLLUP = &H0        'Up arrow of scroll bar
Const DFCS_SCROLLDOWN = &H1      'Down arrow of scroll bar
Const DFCS_SCROLLLEFT = &H2      'Left arrow of scroll bar
                                       
Const DFCS_SCROLLRIGHT = &H3     'Right arrow of scroll bar
                                       
Const DFCS_SCROLLCOMBOBOX = &H5  'Combo box scroll bar
Const DFCS_SCROLLSIZEGRIP = &H8         'Size grip
Const DFCS_SCROLLSIZEGRIPRIGHT = &H10   'Size grip in bottom-right corner of window
Const DFCS_BUTTONCHECK = &H0     'Check box
Const DFCS_BUTTONRADIO = &H4     'Radio button
Const DFCS_BUTTON3STATE = &H8    'Three-state button
Const DFCS_BUTTONPUSH = &H10     'Push button
Const DFCS_INACTIVE = &H100      'Button is inactive (grayed)
Const DFCS_PUSHED = &H200        'Button is pushed
Const DFCS_CHECKED = &H400       'Button is checked
Const DFCS_ADJUSTRECT = &H2000   'Bounding rectangle is
                                 'adjusted to exclude the
                                 'surrounding edge of the
                                 'push button
Const DFCS_FLAT = &H4000         'Button has a flat border
Const DFCS_MONO = &H8000         'Button has a monochrome border

Private Declare Function DrawFrameControl Lib "User32.dll" ( _
    ByVal hDC&, _
    lpRect As RECT, _
    ByVal un1 As Long, _
    ByVal un2 As Long) As Boolean


'''

Private Function MakeRect(ByVal lLeft As Long, _
                          ByVal lTop As Long, _
                          ByVal lWidth As Long, _
                          ByVal lheight As Long) As RECT
    With MakeRect
        .Left = lLeft
        .Top = lTop
        .Right = lLeft + lWidth
        .Bottom = lTop + lheight
    End With

End Function


Private Sub UserControl_Initialize()

End Sub
