VERSION 5.00
Begin VB.Form frmDrop 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Drop Database"
   ClientHeight    =   2085
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4980
   Icon            =   "Drop.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2085
   ScaleWidth      =   4980
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox chkUnregister 
      Caption         =   "Delete registration."
      Height          =   255
      Left            =   720
      TabIndex        =   4
      Top             =   1200
      Value           =   1  'Checked
      Width           =   4155
   End
   Begin VB.CheckBox chkWithFiles 
      Caption         =   "Delete database files."
      Height          =   255
      Left            =   720
      TabIndex        =   3
      Top             =   840
      Value           =   1  'Checked
      Width           =   4155
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3780
      TabIndex        =   2
      Top             =   1620
      Width           =   1155
   End
   Begin VB.CommandButton cmdDrop 
      Caption         =   "&Drop"
      Height          =   375
      Left            =   2520
      TabIndex        =   1
      Top             =   1620
      Width           =   1155
   End
   Begin VB.Image imgDatabase 
      Height          =   480
      Left            =   120
      Picture         =   "Drop.frx":000C
      Top             =   120
      Width           =   480
   End
   Begin VB.Label lblDrop 
      Caption         =   "<Drop>"
      Height          =   495
      Left            =   780
      TabIndex        =   0
      Top             =   240
      Width           =   4095
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmDrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lCommand As Long
Private sDatabase As String
Private sServer As String

Public Function Drop(oDB As DBMLib.Database, bWithFiles As Boolean, bUnregister As Boolean) As Boolean
    Dim s As String
    
    Drop = False
    
    Set imgDatabase.Picture = RES.InstanceIcon(dbmResBMPInstSizeLarge, oDB.InstanceType, dbmResBMPInstStateNone, False)
    
    bUnregister = True
    chkUnregister.Value = vbChecked
    
    If oDB.Version.Number >= dbmVersion72 Then
        bWithFiles = True
        chkWithFiles.Value = vbChecked
    Else
        bWithFiles = False
        chkWithFiles.Value = vbUnchecked
        chkWithFiles.Enabled = False
    End If
    
    sDatabase = oDB.DatabaseName
    sServer = oDB.ServerName
    s = "Do you want drop database '" + sDatabase + "'"
    If Len(sServer) > 0 Then
        s = s + " on server '" + sServer + "'"
    End If
    s = s + "?"

    lblDrop.Caption = s
    
    lCommand = vbCancel
    
    Me.Show vbModal
    
    Select Case lCommand
        Case vbOK:
            bWithFiles = (chkWithFiles.Value = vbChecked)
            bUnregister = (chkUnregister.Value = vbChecked)
            Drop = True
    End Select
    
    Unload Me
End Function

'''

Private Sub cmdCancel_Click()
    lCommand = vbCancel
    Me.Hide
End Sub

Private Sub cmdDrop_Click()
    Dim bWithFiles As String
    Dim bUnregister As String
    Dim sMsg As String
    
    bWithFiles = (chkWithFiles.Value = vbChecked)
    bUnregister = (chkUnregister.Value = vbChecked)
    
    sMsg = "Choose 'Yes' if you are sure you want drop database '" + sDatabase + "'"
    If Len(sServer) > 0 Then
        sMsg = sMsg + " on server '" + sServer + "'"
    End If
    If bWithFiles Then
        sMsg = sMsg + vbCrLf
        sMsg = sMsg + " and delete all database files (devspaces, cofiguration, protocols)"
    End If
    If bUnregister Then
        sMsg = sMsg + vbCrLf
        sMsg = sMsg + " and delete the registration from Database Manager"
    End If
    sMsg = sMsg + "?"
    
    If MsgBox(sMsg, vbYesNo + vbDefaultButton2 + vbQuestion, "Drop Database") = vbYes Then
        lCommand = vbOK
        Me.Hide
    End If
End Sub
