VERSION 5.00
Begin VB.UserControl Hyperlink 
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2265
   ScaleHeight     =   525
   ScaleWidth      =   2265
   Begin VB.Label lblHyperlink 
      BackStyle       =   0  'Transparent
      Caption         =   "SAPDB on the Web"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   120
      MouseIcon       =   "Hyperlink.ctx":0000
      MousePointer    =   99  'Custom
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "Hyperlink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" ( _
    ByVal hWnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long

Const SW_NORMAL = 1

'''

Const DEF_BACKCOLOR = vbButtonFace
Const DEF_CAPTION = "SAP DB on the Web"
Const DEF_URL = "http://www.sapdb.org"

'''

Private sURL As String

'''

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
End Property

Public Property Get Caption() As String
    Caption = lblHyperlink.Caption
End Property
Public Property Let Caption(NewVal As String)
    lblHyperlink.Caption = NewVal
End Property

Public Property Get Font() As IFontDisp
    Set Font = lblHyperlink.Font
End Property
Public Property Set Font(NewVal As IFontDisp)
    Set lblHyperlink.Font = NewVal
End Property

Public Property Get URL() As String
    URL = sURL
End Property
Public Property Let URL(NewVal As String)
    sURL = NewVal
End Property

'''

Public Sub NavigateTo()
    Dim lRC As Long
    Screen.MousePointer = vbHourglass
    lRC = ShellExecute(UserControl.hWnd, "open", sURL, vbNullString, vbNullString, SW_NORMAL)
    Screen.MousePointer = vbDefault
End Sub

'''

Private Sub UserControl_Initialize()
    BackColor = DEF_BACKCOLOR
    Caption = DEF_CAPTION
    URL = DEF_URL
End Sub

Private Sub UserControl_Resize()
    lblHyperlink.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    BackColor = PropBag.ReadProperty("BackColor", DEF_BACKCOLOR)
    Caption = PropBag.ReadProperty("Caption", DEF_CAPTION)
    Set Font = PropBag.ReadProperty("Font")
    URL = PropBag.ReadProperty("URL", DEF_URL)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    PropBag.WriteProperty "BackColor", BackColor, DEF_BACKCOLOR
    PropBag.WriteProperty "Caption", Caption, DEF_CAPTION
    PropBag.WriteProperty "Font", Font
    PropBag.WriteProperty "URL", URL, DEF_URL
End Sub

'''

Private Sub lblHyperlink_Click()
    NavigateTo
End Sub


