VERSION 5.00
Begin VB.Form frmRegParams 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Register Database"
   ClientHeight    =   2685
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4605
   Icon            =   "RegParams.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2685
   ScaleWidth      =   4605
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtName 
      Height          =   315
      Left            =   1440
      TabIndex        =   2
      Top             =   900
      Width           =   3075
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   345
      Left            =   3420
      TabIndex        =   8
      Top             =   2220
      Width           =   1125
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   345
      Left            =   2220
      TabIndex        =   7
      Top             =   2220
      Width           =   1125
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1440
      PasswordChar    =   "*"
      TabIndex        =   6
      Top             =   1740
      Width           =   3075
   End
   Begin VB.TextBox txtUsername 
      Height          =   315
      Left            =   1440
      TabIndex        =   4
      Top             =   1320
      Width           =   3075
   End
   Begin VB.Label lblInfo 
      Caption         =   "Enter a definite registration name for the database instance. As well a user name and a password of the Database Manager Operator."
      Height          =   675
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4395
   End
   Begin VB.Label lblName 
      Caption         =   "&Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin VB.Label lblPassword 
      Caption         =   "&Password:"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label lblUsername 
      Caption         =   "&User Name:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   1380
      Width           =   1215
   End
End
Attribute VB_Name = "frmRegParams"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Enum ButtonsConstants
    btnOK
    btnCancel
End Enum

Private lCommand As ButtonsConstants

'''

Public Sub RegParams(ByVal Server As String, _
                     ByVal Database As String, _
                     Name As String, _
                     Username As String, _
                     Password As String, _
                     Cancel As Boolean)
    Cancel = True
    
    If Len(Server) > 0 Then
        Me.Caption = "Register database '" & Database & "' from server '" & Server & "'"
    Else
        Me.Caption = "Register database '" & Database & "'"
    End If
    
    txtName.Text = Name
    txtUsername.Text = Username
    txtPassword.Text = Password
    
    Me.Show vbModal
    
    Select Case lCommand
        Case btnOK:
            Name = Trim(txtName.Text)
            Username = Trim(txtUsername.Text)
            Password = Trim(txtPassword.Text)
            Cancel = False
        Case btnCancel:
    End Select
    
    Unload Me
End Sub

'''

Private Sub Form_Activate()
    txtUsername.SetFocus
End Sub

'''

Private Sub txtName_Change()
    EnabledOK
End Sub

Private Sub txtName_GotFocus()
    txtName.SelStart = 0
    txtName.SelLength = Len(txtName.Text)
End Sub

Private Sub txtPassword_Change()
    EnabledOK
End Sub

Private Sub txtUsername_Change()
    EnabledOK
End Sub

Private Sub txtUsername_GotFocus()
    txtUsername.SelStart = 0
    txtUsername.SelLength = Len(txtUsername.Text)
End Sub

Private Sub txtPassword_GotFocus()
    txtPassword.SelStart = 0
    txtPassword.SelLength = Len(txtPassword.Text)
End Sub

Private Sub cmdCancel_Click()
    lCommand = btnCancel
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    lCommand = btnOK
    Me.Hide
End Sub

Private Sub EnabledOK()
    cmdOK.Enabled = (Len(Trim(txtName.Text)) > 0) And _
                    (Len(Trim(txtUsername.Text)) > 0) And _
                    (Len(Trim(txtPassword.Text)) > 0)
End Sub
