VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Session"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

Private lIndex As Long

Private sName As String
Private sTerminalID As String
Private sTaskID As String
Private sSessionID As String
Private sNode As String
Private sCatalogCacheSize As String
Private bChecked As Boolean


'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTKernelTraceOption
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

'''

Public Property Get Name() As String
    Name = sName
End Property
Friend Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get TerminalID() As String
    TerminalID = sTerminalID
End Property
Friend Property Let TerminalID(NewVal As String)
    sTerminalID = NewVal
End Property

Public Property Get TaskID() As String
    TaskID = sTaskID
End Property
Friend Property Let TaskID(NewVal As String)
    sTaskID = NewVal
End Property

Public Property Get SessionID() As String
    SessionID = sSessionID
End Property
Friend Property Let SessionID(NewVal As String)
    sSessionID = NewVal
End Property

Public Property Get Node() As String
    Node = sNode
End Property
Friend Property Let Node(NewVal As String)
    sNode = NewVal
End Property

Public Property Get CatalogCacheSize() As String
    CatalogCacheSize = sCatalogCacheSize
End Property
Friend Property Let CatalogCacheSize(NewVal As String)
    sCatalogCacheSize = NewVal
End Property

Public Property Get Checked() As Boolean
    Checked = bChecked
End Property
Public Property Let Checked(ByVal NewVal As Boolean)
    bChecked = NewVal
End Property

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
