VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Panels"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection

Public Property Get Count() As Integer
    Count = oItems.Count
End Property

Public Property Get Item(ByVal Index As Variant) As Panel
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

Friend Sub Add(ByVal oPanel As Panel, _
               ByVal sKey As String)
    
    If Len(sKey) > 0 Then
        oItems.Add oPanel, sKey
    Else
        oItems.Add oPanel
    End If
    
    oPanel.Index = oItems.Count
End Sub

Friend Sub Clear()
    Dim iCount As Integer
    Dim i As Integer
    
    iCount = oItems.Count
    
    For i = 1 To iCount
        oItems.Remove 1
    Next
End Sub

Friend Sub Remove(ByVal Index As Variant)
    Dim iIndex As Integer
    Dim i As Integer
    
    iIndex = Item(Index).Index
    
    oItems.Remove Index
    
    For i = iIndex To oItems.Count
        Item(i).Index = i
    Next
End Sub

