VERSION 5.00
Begin VB.Form frmReinstall 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Reinstall Database Instance"
   ClientHeight    =   1860
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4995
   Icon            =   "Reinstall.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1860
   ScaleWidth      =   4995
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdReinstall 
      Caption         =   "&Reinstall"
      Height          =   375
      Left            =   2460
      TabIndex        =   2
      Top             =   1320
      Width           =   1155
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Default         =   -1  'True
      Height          =   375
      Left            =   3720
      TabIndex        =   1
      Top             =   1320
      Width           =   1155
   End
   Begin VB.Label lblInfo 
      Height          =   975
      Left            =   840
      TabIndex        =   0
      Top             =   180
      Width           =   3975
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   180
      Picture         =   "Reinstall.frx":000C
      Top             =   180
      Width           =   480
   End
End
Attribute VB_Name = "frmReinstall"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private bCancel As Boolean
Private lMousePointer As Long

Public Function Reinstall(sDatabase As String, sServer As String) As Boolean
    Dim s As String
    
    s = ""
    s = s + "Database instance '" + sDatabase + "' "
    If Len(sServer) > 0 Then
        s = s + "on '" + sServer + "' "
    End If
    s = s + "already exists. "
    s = s + "If you reinstall this database instance all data will be lost. "
    s = s + "Do you want reinstall this database instance?"
    
    lblInfo.Caption = s
    
    bCancel = True
    
    lMousePointer = Screen.MousePointer
    Screen.MousePointer = vbDefault
    Show vbModal
    Unload Me
    Screen.MousePointer = lMousePointer
    
    Reinstall = Not bCancel
End Function

Private Sub cmdCancel_Click()
    bCancel = True
    Me.Hide
End Sub

Private Sub cmdReinstall_Click()
    bCancel = False
    Me.Hide
End Sub

